/*
			  Program Name : Basic_Files
			  Package Name : Subroutine Library - Layer 0
			  Purpose      : Basic File classes
			  Institution  : Conroy & Conroy Co.
			  Date Written : 14-Feb-2021
              Written By   : Alan Conroy
              Version      : 2.0

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Copyright (C) 2021 by Conroy & Conroy.  Released to the public domain.

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

            DATE      BY             REASON

        *********************************************************
		*                                                       *
		*           P R O G R A M   P U R P O S E               *
		*                                                       *
		*********************************************************

		This unit has simplified base file functions and classes suitable for
		use in Subroutine Layer 0.
*/

#include "Basic_Files.h";
#include "unistd.h";

bool FileExists( char* name )
{
	return ( access( name, F_OK ) == 0 ) ;
}


FILE Open_Text_File( char* Name, int Flags, int& Err )
{
	FILE* F ;

	Err = 0 ;
	if( ( Flags & FOF_Must_Exist ) != 0 )
	{
		if( !FileExists( Name ) )
		{
			Err = FErr_Not_Found ;
			return ;
		} ;
	} ;

	if( ( Flags & FOF_Append ) != 0 )
	{
		F = fopen( Name, "a+" );
	}
	else
	if( ( Flags & FOF_Create ) != 0 )
	{
		F = fopen( Name, "w+" );
	}
	else
	{
		F = fopen( Name, "r+" );
	} ;
	return F ;
} ;

