/*
			  Program Name : Basic_Files
			  Package Name : Subroutine Library - Layer 0
			  Purpose      : Basic File classes
			  Institution  : Conroy & Conroy Co.
			  Date Written : 14-Feb-2021
			  Written By   : Alan Conroy
			  Version      : 2.0

			  TO THE GLORY OF GOD THROUGH JESUS CHRIST

		Copyright (C) 2021 by Conroy & Conroy.  Released to the public domain.

		*********************************************************
		*                                                       *
		*        M O D I F I C A T I O N   H I S T O R Y        *
		*                                                       *
		*********************************************************

			DATE      BY             REASON

		*********************************************************
		*                                                       *
		*           P R O G R A M   P U R P O S E               *
		*                                                       *
		*********************************************************

		This unit has simplified base file functions and classes suitable for
		use in Subroutine Layer 0.
*/

#ifndef BASIC_FILES_H
	#define BASIC_FILES_H

#include "eDefines.hpp";

#include "_Common.h" ;

// File open flags
const FOF_Read_Write = 0 ; // Open for reading and writing
const FOF_Read_Only = 1 ; // Open for reading only
const FOF_Append = 2 ; // Open and position at end of file
const FOF_Must_Exist = 4 ; // File must exist
const FOF_Create = 8 ; // Create new file/overwrite old file

const FErr_Not_Found = 1 ; // File doesn't exist

FILE Open_Text_File( char* Name, int Flags, int& Err ) ;
bool FileExists( char* name ) ;

#endif

