<?php
/*
			  Program Name : Basic_Files
			  Package Name : Subroutine Library - Layer 0
			  Purpose      : Basic File classes
			  Institution  : Conroy & Conroy Co.
			  Date Written : 14-Feb-2021
              Written By   : Alan Conroy
              Version      : 2.0

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Copyright (C) 2021 by Conroy & Conroy.  Released to the public domain.

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

            DATE      BY             REASON

        *********************************************************
		*                                                       *
		*           P R O G R A M   P U R P O S E               *
		*                                                       *
		*********************************************************

		This unit has simplified base file functions and classes suitable for
		use in Subroutine Layer 0.
*/

require_once "_Common.php";

// File open flags
const FOF_Read_Write = 0 ; // Open for reading and writing
const FOF_Read_Only = 1 ; // Open for reading only
const FOF_Append = 2 ; // Open and position at end of file
const FOF_Must_Exist = 4 ; // File must exist
const FOF_Create = 8 ; // Create new file/overwrite old file

const FErr_Not_Found = 1 ; // File doesn't exist

function FileExists( $name )
{
	return file_exists($name) ;
}


// TSBasic_File method...

class TSBasic_File extends TObject
{
	private $F ;
	private $_Name ;
	
	function Open( $Name, $Flags )
	{
		if( ( $Flags & FOF_Must_Exist ) != 0 )
		{
			if( !FileExists( $Name ) )
			{
				return FErr_Not_Found ;
			} ;
		} ;
		if( ( $Flags & FOF_Append ) != 0 )
		{
			$this->$F = fopen( $Name, "a+" );
		}
		else
		if( ( $Flags & FOF_Create ) != 0 )
		{
			$this->$F= fopen( $Name, "w+" );
		}
		else
		{
			$this->$F = fopen( $Name, "r+" );
		} ;
		$this->$_Name = $Name ;
		return 0 ;
	}


	function Close()
	{
		fclose( $this->$F ) ;
	}


	function eof()
	{
		return feof( $this->$F ) ;
	}


	function FileName()
	{
		return $this->$_Name ;
	}


	function ReadLn()
	{
		return fgets( $this->$F ) ;
	}


	function WriteLn( $Value )
	{
		fwrite( $this->$F, $Value ) ;
	}
} ;


class PSBasic_File extends TSBasic_File
{
} ;


function Open_Text_File( $Name, $Flags, &$Err )
{
	$Err = 0 ;
	if( ( $Flags & FOF_Must_Exist ) != 0 )
	{
		if( !FileExists( $Name ) )
		{
			$Err = FErr_Not_Found ;
			return NULL ;
		} ;
	} ;

	$Fi = new TSBasic_File() ;
	$Err = $Fi->Open( $Name, $Flags ) ;
	if( $Err != 0 )
	{
		return NULL ;
	} ;
	return $Fi ;
} ;
