#              Program Name : Basic_Files
#              Package Name : Subroutine Library - Layer 0
#              Purpose      : Basic File classes
#              Institution  : Conroy & Conroy Co.
#              Date Written : 14-Feb-2021
#              Written By   : Alan Conroy
#              Version      : 2.0
#
#              TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        Copyright (C) 2021 by Conroy & Conroy.  Released to the public domain.
#
#        *********************************************************
#        *                                                       *
#        *        M O D I F I C A T I O N   H I S T O R Y        *
#        *                                                       *
#        *********************************************************
#
#            DATE      BY             REASON
#
#        *********************************************************
#        *                                                       *
#        *           P R O G R A M   P U R P O S E               *
#        *                                                       *
#        *********************************************************
#
#        This unit has simplified base file functions and classes suitable for
#        use in Subroutine Layer 0.

import os.path
from _Common import *

# File open flags
FOF_Read_Write = 0 # Open for reading and writing
FOF_Read_Only = 1 # Open for reading only
FOF_Append = 2 # Open and position at end of file
FOF_Must_Exist = 4 # File must exist
FOF_Create = 8 # Create new file/overwrite old file

FErr_Not_Found = 1 # File doesn't exist

def FileExists( Name ):
    return os.path.isfile(Name)
    

class TSBasic_File( TObject ):
    F = None ;
    _Name = "" ;

    def Open( Name, Flags ):
        E = 0 ;

        if( ( Flags & FOF_Must_Exist ) != 0 ):
            if( not FileExists( Name ) ):
                return FErr_Not_Found
        if( ( Flags & FOF_Append ) != 0 ):
            self.F = open( Name, "a+")
        else:
            if( ( Flags & FOF_Create ) != 0 ):
                self.F = open( Name, "w+")
            else:
                self.F = open( Name, "r+")
        self._Name = Name ;


    def Close():
        self.F.close()


    def EOF():
        return False # Not supported in Python


    def FileName():
        return self._Name


    def ReadLn():
        return self.F.read()


    def WriteLn( Value ):
        self.F.write( Value )


class PSBasic_File( TSBasic_File):
        pass
    

def Open_Text_File( Name, Flags, Err ):
    if( ( Flags & FOF_Must_Exist ) != 0 ):
        if( not FileExists( Name ) ):
            Err = FErr_Not_Found
            return None

    Fi = TSBasic_File() ;
    Err = Fi.Open( Name, Flags ) ;
    if( Err != 0 ):
        return None
    return Fi ;

