<?php
 /*
        Program Name : TCommon_COM_Interface
        Package Name : Subroutine Library - Layer 0
        Purpose      : Abstract virtual common COM interface class
        Institution  : Conroy & Conroy Co.
        Date Written : 21-March-2002
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2002-2015 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TCommon_COM_Interface is a base class definition for COM objects used
        in the Application Foundation.
*/

include_once "COMInter.php";
include_once "_COMInter.php";
include_once "_DebugIn.php";
include_once "_UE.php";

// Constructors and destructors...
    #ifdef CC_Track_Resources
class TCommon_COM_Interface extends TBase_COM_Interface
{
	private $Reference_Count = 0 ;
    private $_Last_Error = NULL ;

	function __construct()
	{
//	    Add_Resource( RT_Object, (int)this) ;
	}


	function __destruct()
	{
//	    Remove_Resource( RT_Object, integer( self ) ) ;
	}


	// API...

	function Initialize()
	{
	    $this->$Reference_Count = 0 ;
	    return NULL;
	}


	function Terminate()
	{
	    Set_Last_Error( NULL ) ;
	    return NULL;
	}


	function Attach()
	{
	    $this->$Reference_Count++ ;
	}


	function Detach()
	{
	    $this->$Reference_Count-- ;
	    if( $this->$Reference_Count < 1 )
	    {
	        Terminate() ;
	        return true;
	    } ;
	    return false;
	}


	function Interface_Version()
	{
	    return 0 ;
	}


	function Facility_ID()
	{
	    return -1 ;
	}


	function Facility_Version()
	{
    	return 0 ;
	}


	function Debugger()
	{
	    return NULL ;
	}


	function Last_Error()
	{
	    return _Last_Error ;
	}


	function Extension()
	{
	    return NULL ;
	}


	// Internal utility routines...

	function Set_Last_Error( $E )
	{
	    if( $E != NULL )
	    {
	        $E->Attach() ;
	    } ;
	    if( $this->$_Last_Error != NULL )
	    {
	        $this->$_Last_Error->Detach() ;
	    } ;
	    $this->$_Last_Error = $E ;
	    return $E ;
	}
} ; // TCommon_COM_Interface
