/*
		Program Name : COMLists
		Package Name : Subroutine Library Layer 0
		Purpose      : COM list class
		Institution  : Conroy & Conroy Co.
		Date Written : 1-Nov-2006
		Written By   : Alan Conroy
		Version      : 1.0

		  Copyright (C) 2006-2021 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

#include "COMLists.hpp"

// API...

int32 stdcall TStandard_COM_List::Get_Capacity()
{
	return _List.size() ;
} ;


void stdcall TStandard_COM_List::Set_Capacity( int32 Value )
{
	_List.resize( Value, 0 ) ;
	if( Value < _Size )
	{
		_Size = Value ;
    }
} ;


void stdcall TStandard_COM_List::Set_Count( int32 Value )
{
	if( Value >= Capacity() )
	{
		Set_Capacity( Value ) ;
	}
	_Size = Value ;
} ;


int32 stdcall TStandard_COM_List::Get_Delta()
{
	return _Delta ;
} ;


void stdcall TStandard_COM_List::Set_Delta( int32 Value )
{
	_Delta = Value ;
} ;


int32 stdcall TStandard_COM_List::Add( int32 Value )
{
	int32 New_Cap ;

	if( _Delta == 0 ) // Equivalent to Delta of 1
	{
		New_Cap = Count() + 1 ;
	}
	else if( _Delta < 0 )
	{
		double R ;

		R = -_Delta ;
		R = R / 100 ;
		R = floor( R * Capacity() ) ;
		if( R == 0.0 )
		{
			R = 1 ;
		} ;
		New_Cap = Capacity() + static_cast<int>( R ) ;
	}
	else
	{
		New_Cap = static_cast<int>( ( ( Count() + _Delta + 1 ) / _Delta ) * _Delta ) ;
	}
	if( New_Cap > Capacity() )
    {
		Set_Capacity( New_Cap ) ;
    } ;
	_List[ _Size ] = Value ;
	_Size++ ;
	return _Size - 1 ;
} ;


int32 stdcall TStandard_COM_List::Get_Count()
{
	return _Size ;
} ;


int32 stdcall TStandard_COM_List::Get_Item( int32 Index )
{
	return _List[ Index ] ;
} ;


void stdcall TStandard_COM_List::Set_Item( int32 Index, int32 Value )
{
	_List[ Index ] = Value ;
} ;


int32 stdcall TStandard_COM_List::IndexOf( int32 Value )
{
	std::vector<int32>::iterator it;

	it = std::find(_List.begin(), _List.end(), Value);
	if(it != _List.end())
    {
		return distance(_List.begin(), it);
	}
    return -1;
} ;

