/*
		Program Name : COMLists
		Package Name : Subroutine Library Layer 0
		Purpose      : COM list class
		Institution  : Conroy & Conroy Co.
		Date Written : 1-Nov-2006
		Written By   : Alan Conroy
		Version      : 1.0

		  Copyright (C) 2006-2021 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

#ifndef COMLISTS_HPP
	#define COMLISTS_HPP

#include "eDefines.hpp"

// C&C Subroutine Library - Layer 0...
#include "_COMLists.hpp" // TCOM_List
#include <vector> // std::vector
#include <algorithm> // std::find

using namespace std;

class TStandard_COM_List: public TCOM_List
{
	private: // Instance data...
		vector <int32>_List ;
		int32 _Delta ;
		int32 _Size ; // Logical size

	public: // API...
		int32& operator[](int idx) { return _List[idx]; }
		const int32& operator[](int idx) const { return _List[idx]; }
		virtual int32 stdcall Add( int32 Value ) ;
		virtual int32 stdcall Get_Count() ;
		virtual void stdcall Set_Count( int32 Value ) ;
		virtual int32 stdcall Get_Item( int32 Index ) ;
		virtual void stdcall Set_Item( int32 Index, int32 Value ) ;
		virtual int32 stdcall Get_Capacity() ;
		virtual void stdcall Set_Capacity( int32 Value ) ;
		virtual int32 stdcall Get_Delta() ;
		virtual void stdcall Set_Delta( int32 Value ) ;
		virtual int32 stdcall IndexOf( int32 Value ) ;
} ; // TStandard_COM_List

#endif

