<?php
 /*
		Program Name : COMLists
		Package Name : Subroutine Library Layer 0
		Purpose      : COM list class
		Institution  : Conroy & Conroy Co.
		Date Written : 1-Nov-2006
		Written By   : Alan Conroy
		Version      : 1.0

		  Copyright (C) 2006-2021 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

// C&C Subroutine Library - Layer 0...
require_once "_COMLists.php" ; // TCOM_List

class TStandard_COM_List extends TCOM_List implements ArrayAccess
{
	// Instance data...
	private $_List = array() ;
	private $_Delta = 0 ;
	private $_Size = 0 ; // Logical size

	// ArrayAccess
	public function offsetExists( $offset )
	{
    	return isset( $this->_List[ $offset ] );
  	}

	public function offsetGet($offset)
	{
    	return $this->$_List[ $offset ] ;
  	}

	public function offsetSet($offset , $value)
	{
    	$this->$_List[ $offset ] = $value ;
	}

	public function offsetUnset($offset)
	{
    	unset( $this->$_List[ $offset ] ) ;
	}

	// API...
	public function Get_Capacity()
	{
		return count( $this->$_List ) ;
	}


	public function Set_Capacity( $Value )
	{
		// Do nothing
	}


	public function Get_Delta()
	{
		return $this->$_Delta ;
	}


	public function Set_Delta( $Value )
	{
		$this->$_Delta = $Value ;
	}


	public function Add( $Value )
	{
		$this->$_List[] = $Value ;

		return count( $this->$_List ) - 1 ;
	}


	public function Get_Count()
	{
		return count( $this->$_Size ) ;
	}


	public function Set_Count()
	{
		// Does nothing in PHP
	}


	public function Get_Item( $Index )
	{
		return $this->$_List[ $Index ] ;
	}


	public function Set_Item( $Index, $Value )
	{
		$this->$_List[ $Index ] = $Value ;
	}


	public function IndexOf( $Value )
	{
		if(!in_array($Value,$this->$_List))
		{
			return -1;
		}
		return array_search( $Value, $this->$_List );
	}


	public function Items( $Index )
	{
		return $this->Get_Item( $Index ) ;
	}
	
	
	public function Count()
	{
		return $this->Get_Count();
	}


	public function Delta()
	{
		return $this->Get_Delta();
	}


	public function Capacity()
	{
		return $this->Get_Capacity() ;
	}
} ; // TStandard_COM_List

