#   Program Name : COMLists\
#   Package Name : Subroutine Library Layer 0
#   Purpose      : COM list class
#   Institution  : Conroy & Conroy Co.
#   Date Written : 1-Nov-2006
#   Written By   : Alan Conroy
#   Version      : 1.0
#
#     Copyright (C) 2006-2021 by Alan Conroy.  All rights reserved.
#
#   TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#   *************************************************************
#   *                                                           *
#   *        M O D I F I C A T I O N   H I S T O R Y            *
#   *                                                           *
#   *************************************************************
#
#     DATE        BY          REASON
#
#   *************************************************************
#   *                                                           *
#   *        P R O G R A M   P U R P O S E                      *
#   *                                                           *
#   *************************************************************

from _COMLists import * # TCOM_List

class TStandard_COM_List( TCOM_List ):
  # Instance data...
  _List = []
  _Delta = 0
  _Size = 0 # Logical size

  def Get_Capacity(self):
    return self.Count()


  def Set_Capacity( self, Value ):
    pass


  def Get_Delta(self):
    return self._Delta


  def Set_Delta( self, Value ):
    self._Delta = Value


  def Add( self, Value ):
    self._List.append( Value ) ;

    return self.Count() - 1


  def Get_Count(self):
    return len(self._List)


  def Set_Count(self):
    pass


  def Get_Item( self, Index ):
    return self._List[ Index ]


  def Set_Item( self, Index, Value ):
    self._List[ Index ] = Value


  def IndexOf( self, Value ):
        i = 0
        for i in range(0, self.Count()-1):
            if( self._List[i]==Value ):
                return i
        return -1;


  def Items( self, Index ):
    return self.Get_Item( Index )
  
  
  def Count(self):
    return self.Get_Count()


  def Delta(self):
    return self.Get_Delta()


  def Capacity(self):
    return self.Get_Capacity()

##  def Test(self):
##        Loop=0
##    
##        if( self.Count() != 0 ):
##            print( "Count <> 0" )
##            sys.exit()
##        if( self.IndexOf( 1 ) != -1 ):
##            print( "IndexOf is invalid" )
##            sys.exit()
##        for Loop in range(0,6):
##            self.Add( Loop * 2 )
##        if( self.Count() != 6 ):
##            print( "Count <> 6" )
##            sys.exit()
##        for Loop in range(0,6):
##            if( self.Items( Loop ) != Loop * 2 ):
##                print( "List returned wrong value" )
##                sys.exit()
##        for Loop in range(0,6):
##            self.Set_Item( Loop, Loop * 2 + 1 )
##        for Loop in range(0,6):
##            if( self.Items( Loop ) != Loop * 2 + 1 ):
##                print( "Item incorrect" )
##                sys.exit()
##        if( self.IndexOf( 3 ) != 1 ):
##            print( "Indexof incorrect" )
##            sys.exit()
