/*
		Program Name : Collect
		Package Name : Subroutine Library - Layer 0
		Purpose      : TCollection
		Institution  : Conroy & Conroy Co.
		Date Written : 03-Jul-1996
		  Last Modified: 17-May-2002
		Written By   : Alan Conroy
		Version      : 2.0A

		Copyright 1996-2021 by Alan Conroy.  Released to the public domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		  1-Nov-2002    EAC         Fix AtInsert.  Correct BP compilation error.

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************

		  This unit provides various TCollection classes.
*/

using System ;
using System.Collections.Generic;

namespace Collect_unit
{
	public class TCollection
	{
		private List<IntPtr> _List ;

		public TCollection( int ALimit, int ADelta )
		{
			 _List = new List<IntPtr>() ;
			 _List.Capacity = ALimit ;
		}


		public IntPtr At( int Index )
		{
			if( ( Index < 0 ) || ( Index > _List.Count - 1 ) )
			{
				return (IntPtr)0 ;
			}
			else
			{
				return _List[ Index ] ;
			} ;
		}


		public void AtPut( int Index, IntPtr Value )
		{
			_List[ Index ] = Value ;
		}


		public int Count()
		{
			return _List.Count ;
		}


		public void Delete( IntPtr Item )
		{
			_List.Remove( Item ) ;
		}


		public void AtDelete( int Item )
		{
			_List.RemoveAt( Item ) ;
		}


		public int IndexOf( IntPtr Item )
		{
			return _List.IndexOf( Item ) ;
		}


		public void Insert( IntPtr Item )
		{
			_List.Add( Item ) ;
		}


		public void DeleteAll()
		{
			_List.Clear() ;
		}

		public void AtInsert( int Index, IntPtr Item )
		{
			_List.Insert( Index, Item ) ;
		}


		public void SetLimit( int ALimit )
		{
			_List.Capacity = ALimit ;
		}


		public int Limit()
		{
			return _List.Capacity ;
		}
	} ; // TCollection


	public class TString_Collection
	{
		private List<string> _List ;

		public TString_Collection( int ALimit, int ADelta )
		{
			 _List = new List<string>() ;
			 _List.Capacity = ALimit ;
		}


		public string At( int Index )
		{
			if( ( Index < 0 ) || ( Index > Count() - 1 ) )
			{
				return "" ;
			}
			else
			{
				return _List[ Index ] ;
			} ;
		}


		public void AtPut( int Index, string Value )
		{
			_List[ Index ] = Value ;
		}


		public int Count()
		{
			return _List.Count ;
		}


		public void Delete( string Item )
		{
			_List.Remove( Item ) ;
		}


		public void AtDelete( int Item )
		{
			_List.RemoveAt( Item ) ;
		}


		public int IndexOf( string Item )
		{
			return _List.IndexOf( Item ) ;
		}


		public int Index_Of_Uppercase( string Item )
		{
			Item = Item.ToUpper() ;
			int count = Count() ;
			for( int Loop = 0; Loop < count - 1; Loop++ )
			{
				if( Item == At( Loop ).ToUpper() )
				{
					return Loop ;
				} ;
			} ;
			return -1 ;
		}


		public void Insert( string Item )
		{
			_List.Add( Item ) ;
		}


		public void DeleteAll()
		{
			_List.Clear() ;
		}


		public void AtInsert( int Index, string Item )
		{
			_List.Insert( Index, Item ) ;
		}


		public void SetLimit( int ALimit )
		{
			_List.Capacity = ALimit ;
		}


		public int Limit()
		{
			return _List.Capacity ;
		}
	} // TString_Collection


	public class TInteger_Collection
	{
		private List<int> _List ;

		public TInteger_Collection( int ALimit, int ADelta )
		{
			 _List = new List<int>() ;
			 _List.Capacity = ALimit ;
		}


		public int At( int Index )
		{
			if( ( Index < 0 ) || ( Index > Count() - 1 ) )
			{
				return 0 ;
			}
			else
			{
				return _List[ Index ] ;
			} ;
		}


		public void AtPut( int Index, int Value )
		{
			_List[ Index ] = Value ;
		}


		public int Count()
		{
			return _List.Count ;
		}


		public void Delete( int Item )
		{
			_List.Remove( Item ) ;
		}


		public void AtDelete( int Item )
		{
			_List.RemoveAt( Item ) ;
		}


		public int IndexOf( int Item )
		{
			return _List.IndexOf( Item ) ;
		}


		public void Insert( int Item )
		{
			_List.Add( Item ) ;
		}


		public void DeleteAll()
		{
			_List.Clear() ;
		}


		public void AtInsert( int Index, int Item )
		{
			_List.Insert( Index, Item ) ;
		}


		public void SetLimit( int ALimit )
		{
			_List.Capacity = ALimit ;
		}


		public int Limit()
		{
			return _List.Capacity ;
		}
	} ; // TInteger_Collection


	public class PString_Collection : TString_Collection
	{
		public PString_Collection( int ALimit, int ADelta ): base(ALimit, ADelta)
		{
		}
	}
}
