/*
        Program Name : Collect
        Package Name : Subroutine Library - Layer 0
        Purpose      : TCollection for Delphi
        Institution  : Conroy & Conroy Co.
        Date Written : 03-Jul-1996
	    Last Modified: 17-May-2002
        Written By   : Alan Conroy
        Version      : 2.0A

        Copyright 1996-2002 by Alan Conroy.  Released to the public domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

          1-Nov-2002    EAC         Fix AtInsert.  Correct BP compilation error.

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides the TCollection definition to reduce the
        differences between the various versions of Borland Pascal/Delphi.  This
        is not in Compatib beecause of unit dependancy issues.  It also provides
        some other TCollection variants.
*/

#ifndef COLLECT_HPP
	#define COLLECT_HPP

#include "eDefines.hpp"
#include <string>
#include <vector>

using namespace std;

class TCollection
{
    private:
		vector <void*>List ;

    public:
        void* At( int Index ) ;
		void AtPut( int Index, void* Value ) ;
        int Count() ;
        void Delete( void* Item ) ;
        void AtDelete( int Item ) ;
        int IndexOf( void* Item ) ;
        void Insert( void* Item ) ;
        void DeleteAll() ;
        void AtInsert( int Index, void* Item ) ;
        void SetLimit( int ALimit ) ;
        int Limit() ;
  #ifdef CC_Regression_Test
	void Test() ;
  #endif
} ;

class TString_Collection
{
    private:
        vector <string>List ;

    public:
        string At( int Index ) ;
        void AtPut( int Index, string Value ) ;
        int Count() ;
        void Delete( string Item ) ;
        void AtDelete( int Item ) ;
        int IndexOf( string Item ) ;
        int Index_Of_Uppercase( string Item ) ;
        void Insert( string Item ) ;
        void DeleteAll() ;
        void AtInsert( int Index, string Item ) ;
        void SetLimit( int ALimit ) ;
        int Limit() ;
  #ifdef CC_Regression_Test
	void Test() ;
  #endif
} ;

class TInteger_Collection
{
    private:
        vector <int>List ;

    public:
        int At( int Index ) ;
        void AtPut( int Index, int Value ) ;
        int Count() ;
        void Delete( int Item ) ;
        void AtDelete( int Item ) ;
        int  IndexOf( int Item ) ;
        void Insert( int Item ) ;
        void DeleteAll() ;
        void AtInsert( int Index, int Item ) ;
        void SetLimit( int ALimit ) ;
        int Limit() ;
  #ifdef CC_Regression_Test
		void Test() ;
  #endif
} ;
     
#define PCollection *TCollection
#define PInteger_Collection *TInteger_Collection
#define PString_Collection *TString_Collection

  #ifdef CC_Regression_Test
void Test_Unit() ;
  #endif

#endif
