<?php
/*
        Program Name : Collect
        Package Name : Subroutine Library - Layer 0
        Purpose      : TCollection for Delphi
        Institution  : Conroy & Conroy Co.
        Date Written : 03-Jul-1996
	      Last Modified: 17-May-2002
        Written By   : Alan Conroy
        Version      : 2.0A

        Copyright 1996-2021 by Alan Conroy.  Released to the public domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

          1-Nov-2002    EAC         Fix AtInsert.  Correct BP compilation error.

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	       This unit provides the TCollection classes.
*/

// TCollection methods...

// API...

class TCollection
{
	private $List = array();

	function At( $Index )
	{
	    if( ( $Index < 0 ) || ( $Index > self::Count() - 1 ) )
	    {
	        return NULL ;
	    } 
        return $this->$List[ $Index ] ;
	}


	function AtPut( $Index, $Value )
	{
    	$this->$List[ $Index ] = $Value ;
	}


	function Count()
	{
    	return count($this->$List) ;
	}


	function Delete( $Item )
	{
	    for($i=0;$i<self::Count();$i++)
		{
			if($this->$List[$i]==$Item)
			{
				unset($this->$List[$i]);
			}
		}	
	}


	function AtDelete( $Item )
	{
	    unset($this->$List[$Item]);
		if($Item<count($this->$List))
		{
			$this->$List = array_values($this-$List); // Reorder keys
		}
	}


	function IndexOf( $Item )
	{
		if(!in_array($Item,$this->$List))
		{
			return -1;
		}
		return array_search( $Item, $this->$List );
	}


	function Insert( $Item )
	{
	    $this->$List[]=$Item ;
	}


	function DeleteAll()
	{
	    $this->$List = array();
	}


	function AtInsert( $Index, $Item )
	{
		if($Index<0)
		{
			$index=0;
		}
		if(array_key_exists($Index, $this->$List))
		{
		    foreach($this->$List as $key => $value)
			{
				$old=0;
				if( $key >= $Index )
				{
					$new=$value;
					$this->$List[$key]=$old;
					$old=$new;
				}
			}
		}
		$this->$List[$Index]=$Item;
	}


	function SetLimit( $ALimit )
	{
	}


	function Limit()
	{
	    return self::Count() ;
	}


	function Test()
	{
		if( self::Count() != 0 )
	    {
	       echo "Count &lt;&gt; 0" ;
	       exit ;
	    } ;
	    if( self::IndexOf( 1 ) != -1 )
	    {
	       echo "IndexOf is invalid" ;
	       exit ;
	    } ;
	    for( $Loop = 0; $Loop <= 5; $Loop++ )
	    {
	        self::Insert( $Loop * 2 ) ;
	    } ;
	    if( self::Count() != 6 )
	    {
	       echo "Count &lt;&gt; 6" ;
	       exit ;
	    } ;
	    for( $Loop = 0; $Loop <= 5; $Loop++ )
	    {
	        if( self::At( $Loop ) != $Loop * 2 )
	        {
	           echo "At returned wrong value" ;
	           exit ;
	        } ;
	    } ;
	    for( $Loop = 0; $Loop <= 5; $Loop++ )
	    {
	        self::AtPut( $Loop, $Loop * 2 + 1 ) ;
	    } ;
	    for( $Loop = 0; $Loop <= 5; $Loop++ )
	    {
	        if( self::At( $Loop ) != $Loop * 2 + 1 )
	        {
	           echo "AtPut incorrect" ;
	           exit ;
	        } ;
	    } ;
	    if( self::IndexOf( 3 ) != 1 )
	    {
	       echo "Indexof incorrect" ;
	       exit ;
	    } ;
	    self::Delete( 3 ) ;
	    if( self::IndexOf( 3 ) != -1 )
	    {
	       echo "Delete malfunctioned" ;
	       exit ;
	    } ;
	    for( $Loop = self::Count() - 1; $Loop >= 0; $Loop-- )
	    {
	        self::AtDelete( $Loop ) ;
	    } ;
	    if( self::Count() != 0 )
	    {
	       echo "Count &lt;&gt; 0" ;
	       exit ;
	    } ;
	    if( self::At( -1 ) != NULL )
	    {
	       echo "At( -1 ) did not return 0" ;
	       exit ;
	    } ;
	}
} ; // TCollection


class TString_Collection extends TCollection
{
};

class TInteger_Collection extends TCollection
{
} ;

class PCollection extends TCollection
{
} ;

class  PString_Collection extends TCollection
{
} ;

class  PInteger_Collection extends TCollection
{
} ;
