#        Program Name : Collect
#        Package Name : Subroutine Library - Layer 0
#        Purpose      : TCollection for Delphi
#        Institution  : Conroy & Conroy Co.
#        Date Written : 03-Jul-1996
#       Last Modified: 17-May-2002
#        Written By   : Alan Conroy
#        Version      : 2.0A
#
#        Copyright 1996-2002 by Alan Conroy.  Released to the public domain.
#       
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON
#
#          1-Nov-2002    EAC         Fix AtInsert.  Correct BP compilation error.
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************
#
#     This unit provides the TCollection definition to reduce the
#        differences between the various versions of Borland Pascal/Delphi.  This
#        is not in Compatib beecause of unit dependancy issues.  It also provides
#        some other TCollection variants.

import sys

def EditUp( S ):
    return S.upper()


# TCollection methods...

class TCollection:

    List = []

    def At( self, Index ):
        if( ( Index < 0 ) or ( Index > self.Count() - 1 ) ):
            return None
        return self.List[ Index ]


    def AtPut( self, Index, Value ):
        self.List[ Index ] = Value


    def Count(self):
        return len(self.List)


    def Delete( self, Item ):
        i = self.Count() - 1
        while(i>=0):
            if(self.List[i]==Item):
                self.AtDelete(i)
            i=i-1


    def AtDelete( self, Item ):
        del self.List[ Item ]


    def IndexOf( self, Item ):
        i = 0
        for i in range(0, self.Count()-1):
            if(self.List[i]==Item):
                return i
        return -1;


    def Insert( self, Item ):
        self.List.append( Item )


    def DeleteAll(self):
        self.List.clear()


    def AtInsert( self, Index, Item ):
        self.List.insert( Index, Item )


    def SetLimit( self, ALimit ):
        return None


    def Limit(self):
        return Count()


##    def Test(self):
##        Loop=0
##    
##        if( self.Count() != 0 ):
##            print( "Count <> 0" )
##            sys.exit()
##        if( self.IndexOf( 1 ) != -1 ):
##            print( "IndexOf is invalid" )
##            sys.exit()
##        for Loop in range(0,6):
##            self.Insert( Loop * 2 )
##        if( self.Count() != 6 ):
##            print( "Count <> 6" )
##            sys.exit()
##        for Loop in range(0,6):
##            if( self.At( Loop ) != Loop * 2 ):
##                print( "At returned wrong value" )
##                sys.exit()
##        for Loop in range(0,6):
##            self.AtPut( Loop, Loop * 2 + 1 )
##        for Loop in range(0,6):
##            if( self.At( Loop ) != Loop * 2 + 1 ):
##                print( "AtPut incorrect" )
##                sys.exit()
##        if( self.IndexOf( 3 ) != 1 ):
##            print( "Indexof incorrect" )
##            sys.exit()
##        self.Delete( 3 )
##        if( self.IndexOf( 3 ) != -1 ):
##            print( "Delete malfunctioned" )
##            sys.exit()
##        Loop=self.Count()-1;
##        while(Loop>=0):
##            self.AtDelete( Loop )
##            Loop=Loop-1
##        if( self.Count() != 0 ):
##            print( "Count <> 0" )
##            sys.exit()
##        if( self.At( -1 ) != None ):
##            print( "At( -1 ) did not return 0" )
##            sys.exit()

class TString_Collection(TCollection):
    pass

class TInteger_Collection(TCollection):
    pass

class PCollection(TCollection):
    pass

class PString_Collection(TCollection):
    pass

class PInteger_Collection(TCollection):
    pass
