<?php
/*
        Program Name : CommBase
        Package Name : Subroutine Library - Layer 0
        Purpose      : Common base objects
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Mar-2002
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2002-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

*/

require_once('_Common.php'); // TObject
require_once('_UE.php');
require_once "_DebugIn.php";
require_once "_Propert.php";
require_once "_Streams.php";
require_once "_ObjectF.php" ; // Object_Factory

// Serialization/deserialization options...
define('SDO_Visual',1) ; // Visual aspects
define('SDO_Deep',2) ; // Include serialization of embedded/reference objects
// 4-32768 == reserved for future use
define('SDO_User',65536) ; // This flag (and following) reserved for the user

class TBase_Object extends TObject
{
	// Instance data...
    private $_Properties = NULL ;
    private $_Last_Error = NULL ;
	private $_Reference_Count = 0 ;

    // API...
	public function Attach()
	{
		$this->$_Reference_Count++;
	}


	public function Detach()
	{
	    $this->$_Reference_Count-- ;
		return false ;
	}


    public function Is_Class( $Name )
	{
	    if ( $Name == get_class() )
		{
			return true;
	    }
	    return parent::Is_Class($Name);
	}


	public function Reference_Count()
	{
		return $this->$_Reference_Count;		
	}


    protected function Set_Last_Error( $X )
	{
	    $this->$_Last_Error = $X ;
		return $X;
	}

    // API...

    public function Properties()
	{
	    if( !is_object( self::$_Properties ) )
	    {
	        $this->$_Properties = Dynamic_Properties() ;
	    } ;
	    return $this->$_Properties ;
	}
	
    public function Debugger()
	{
	    return NULL ;
	}

    public function Test()
	{
    	// Do nothing
	}

    public function Deserialize( $Stream, $Options )
	{
	    return False ;
	}

    public function Serialize( $Stream, $Options )
	{
	    return False ;
	}

	public function Load( $Stream )
	{
	    return False ;
	}

    public function Persist( $Stream )
	{
	    return False ;
	}

	public function Last_Error()
	{
	    return $this->$_Last_Error ;
	}
} ; // TBase_Object


class PBase_Object extends TBase_Object
{
};


class TBase_Delphi_Object extends TBase_Object
{
};

