<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TBase_Object</b><br>
What: Class<br>
Ancestor: <a href="TObject.php">TObject</a><br>
File: CommBase<br>
Layer: 0<br>
Platforms: C++, C#, Javascript, Pascal (All), PHP, Python<br>
<br>
This class is the base class for standard static classes in the subroutine library.  
The class contains the following methods:
</p>
<p>
<b>Attach</b><br>
void Attach()<br>
procedure Attach<br>
Increments the reference count for the object.
</p>
<p>
<b>Clone</b><br>
TDelphi_Object* Clone()<br>
function Clone : TDelphi_Object<br>
Returns a new object which is a clone of this object.  Note: this must be handled
by descendant classes.  The TDelphi_Object returns null.
</p>
<p>
<b>Debugger</b><br>
TDebug_Interface* Debugger()<br>
function Debugger : TDebug_Interface<br>
Returns a debugger instance for the class, or null if not supported.
</p>
<p>
<b>Deserialize</b><br>
bool Deserialize( TStream* Stream )<br>
function Deserialize( Stream : TStream ) : boolean<br>
Restores the object state from the specified serialization.
</p>
<p>
<b>Detach</b><br>
void Detach()<br>
procedure Detach<br>
Decrements the reference count for the object.  If the reference count reaches 0,
the object self-destructs.  Note that self-destruction only occurs on platforms without
automatic garbage collection.
</p>
<p>
<b>Is_Class</b><br>
bool Is_Class( const string Name )<br>
function Is_Class( const Name : string ) : boolean<br>
Returns true if the object is the specified class, or an ancestor of it.
</p>
<p>
<b>Load</b><br>
bool Load( TStream* Stream )<br>
function Load( Stream : TStream ) : boolean<br>
Sets the instance state from a binary representation saved via Persist.
</p>
<p>
<b>Persist</b><br>
bool Persist( TStream* Stream )<br>
function Persist( Stream : TStream ) : boolean<br>
Writes a binary definition of the object to the specified stream which can be used
by Load to restore the current state.
</p>
<p>
<b>Properties</b><br>
TDynamic_Properties* Properties()<br>
function Properties : TDynamic_Properties<br>
Returns an instance of dynamic properties for this instance.
</p>
<p>
<b>Reference_Count</b><br>
int Reference_Count()<br>
function Reference_Count : integer<br>
Returns the current reference count.
</p>
<p>
<b>Serialize</b><br>
bool Serialize( TStream* Stream )<br>
function Serialize( Stream : TStream ) : boolean<br>
Writes a string serialization to the passed string which can be used to restore an
instance of this class to its current state.
</p>
<p>
<b>Test</b><br>
void Test()<br>
procedure Test<br>
Runs a regression test for the class.
</p>
