<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TBase_Stream</b><br>
What: class<br>
Ancestor: <a href="TCommon_COM_Interface.php">TCommon_COM_Interface</a><br>
File: _COMLists<br>
Layer: 0<br>
Platforms: C++, C#, Javascript, Pascal (All), PHP, Python<br>
<br>
This base stream class makes writing descendent stream classes easier.  The following
methods need not be reimplemented in descendents: Write_String, Write_Line, Write_Line_String,
Read_Line, and Read_String.  Note that these streams have no relationship (except
in concept) to streams on any of the platforms.  The class has the following methods:
</p>
<p>
<b>At_End</b><br>
bool At_End()<br>
function At_End : boolean<br>
Returns True if there is no more data in the stream to read.
</p>
<p>
<b>Read</b><br>
int32 Read( void* Buffer, int32& _Size )<br>
function Read( var Buffer ; var _Size : longint ) : longint<br>
Reads the specified number of bytes from the stream.  Size is modified to be the 
actual bytes transferred.
</p>
<p>
<b>Read_Line</b><br>
void Read_Line( void* Buffer, int32& _Size )<br>
procedure Read_Line( var Buffer ; var _Size : longint )<br>
Reads one line of input, up to the size of the buffer.
The line is assumed to end at an ASCII 13 code.  The
ASCII 13 code is not included in the returned data.
Size is modified to be the actual bytes transferred.
</p>
<p>
<b>Read_String</b><br>
string Read_String()<br>
function Read_String : string<br>
Reads one line of input.  The line is assumed to end at
an ASCII 13 code.  The ASCII 13 code is not included in
the returned data.
</p>
<p>
<b>Seek</b><br>
void Seek( int32 Position )<br>
procedure Seek( Position : longint )<br>
Position to specified byte within streamed data.
</p>
<p>
<b>Write</b><br>
void Write( void* Buffer, int32 _Size )<br>
procedure Write( var Buffer ; _Size : longint )<br>
Writes the specified buffer, of the specified size in bytes, to the stream.
</p>
<p>
<b>Write_Line</b><br>
void Write_Line( char* Buffer )<br>
procedure Write_Line( Buffer : PChar )<br>
Writes the specified null-terminated text to the stream.
An ASCII code 13 is appended to the text on output.
</p>
<p>
<b>Write_Line_String</b><br>
void Write_Line_String( const string Buffer )<br>
procedure Write_Line_String( const Buffer : string )<br>
Writes the specified string to the stream.
An ASCII code 13 is appended to the text on output.
</p>
<p>
<b>Write_String</b><br>
void Write_String( const string Buffer )<br>
procedure Write_String( const Buffer : string )<br>
Writes the specified string to the stream.
</p>
