<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TCOM_List</b><br>
What: class<br>
Ancestor: <a href="TCommon_COM_Interface.php">TCommon_COM_Interface</a><br>
File: _COMLists<br>
Layer: 0<br>
Platforms: C++, Javascript, Pascal (All), PHP, Python<br>
<br>
This abstract base class is used to interface to a text editor.  The methods which
start with underscores are non stdcall interfaces for property handlers and should
not be called directly by any code that uses the class.  It has the following methods:
</p>
<p>
<b>_Get_Capacity</b><br>
int32 _Get_Capacity()<br>
function _Get_Capacity : longint<br>
Returns the current capacity (physical size).
</p>
<p>
<b>_Get_Count</b><br>
int32 _Get_Count()<br>
function _Get_Count : longint<br>
Returns the current count (logical size).
</p>
<p>
<b>_Get_Delta</b><br>
int32 _Get_Delta()<br>
function _Get_Delta : longint<br>
Returns the current list delta.
</p>
<p>
<b>_Get_Item</b><br>
int64 _Get_Item( int64 Index )<br>
function _Get_Item( Index : int64 )<br>
Returns the item at the specified index.
</p>
<p>
<b>_Set_Capacity</b><br>
void _Set_Capacity( int32 Value )<br>
procedure _Set_Capacity( Value : longint )<br>
sets the list's capacity (physiscal size).
</p>
<p>
<b>_Set_Count</b><br>
void _Set_Count( int32 Value )<br>
procedure _Set_Count( Value : longint )<br>
Sets the logical size of the list.
</p>
<p>
<b>_Set_Delta</b><br>
void _Set_Delta( int32 Value )<br>
procedure _Set_Delta( Value : longint )<br>
Sets the list's delta value.  This is the number of items that are added to the capacity
whenever the list needs to be expanded.  If negative, this is the percentage of the
current list size that the list is to be expanded.
</p>
<p>
<b>_Set_Item</b><br>
void _Set_Item( int64 Index, int64 Value )<br>
procedure _Set_Item( Index, Value : int64 )<br>
Set the value at the specified index to the specified value.
</p>
<p>
<b>Add</b><br>
int32 Add( int32 Value )<br>
function Add( Value : longint ) : longint<br>
Adds a value to the list and returns the index of the added item.
</p>
<p>
<b>Capacity</b><br>
int32 Capacity()<br>
property Capacity : longint read _Get_Capacity  write _Set_Capacity<br>
Access to the capacity.
</p>
<p>
<b>Count</b><br>
int32 Count()<br>
property Count : longint read _Get_Count write _Set_Count<br>
Access to the count.
</p>
<p>
<b>Delta</b><br>
int32 Delta()<br>
property Delta : longint read _Get_Delta write _Set_Delta<br>
Access to the delta value.
</p>
<p>
<b>Get_Capacity</b><br>
int32 Get_Capacity()<br>
function Get_Capacity : longint<br>
Returns the capacity (physical size) of the list.
</p>
<p>
<b>Get_Count</b><br>
int32 Get_Count()<br>
function Get_Count : longint<br>
Returns the number of items in the list (logical size).
</p>
<p>
<b>Get_Delta</b><br>
int32 Get_Delta()<br>
function Get_Delta : longint<br>
Returns the delta value.
</p>
<p>
<b>Get_Item</b><br>
int32 Get_Item( int32 Index )<br>
function Get_Item( Index : longint ) : longint<br>
Returns the item at the specified index.
</p>
<p>
<b>Items</b><br>
int32 Items( int64 Index )<br>
property Items[ Index : int64 ] : int64 read _Get_Item write _Set_Item ; default<br>
Access to the item at the specified index.
</p>
<p>
<b>Set_Capacity</b><br>
void Set_Capacity( int32 Value )<br>
procedure Set_Capacity( Value : longint )<br>
Sets the physical size of the list.  The count is not altered unless the capacity is
set to a value less than the current count.
</p>
<p>
<b>Set_Count</b><br>
void Set_Count( int32 Value )<br>
procedure Set_Count( Value : longint )<br>
Sets the number of items in the list, truncating or expanding the list as necessary.
</p>
<p>
<b>Set_Delta</b><br>
void Set_Delta( int32 Value )<br>
procedure Set_Delta( Value : longint )<br>
Sets the delta value.  This is the number of items that are added to the capacity
whenever the list needs to be expanded.  If negative, this is the percentage of the
current list size that the list is to be expanded.
</p>
<p>
<b>Set_Item</b><br>
void Set_Item( int32 Index, int32 Value )<br>
procedure Set_Item( Index, Value : longint )<br>
Sets the specified index to the specified value.
</p>
