<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TCOM_Object_Librarian</b><br>
What: class<br>
Ancestor: <a href="TCommon_COM_Interface.php">TCommon_COM_Interface</a><br>
File: <a href="_Lib.php">_Lib</a><br>
Layer: 1<br>
Platforms: C++, Pascal (Delphi)<br>
<br>
Defines information about a module.  It has the following methods, all of which use
stdcall calling convention:
</p>
<p>
<b>Create_New</b><br>
void Create_New( char* Command, int32 Language_Id, int32 Typ )<br>
procedure Create_New( Command : String ; Language_Id, Typ : Integer)<br>
Creates a new module with the given specification entry, ID, and type in the library.
</p>
<p>
<b>Creation_Day</b><br>
int32 Creation_Day()<br>
function Creation_Day : int32<br>
Returns the day of month of library creation.
</p>
<p>
<b>Creation_Hour</b><br>
int Creation_Hour()<br>
function Creation_Hour : integer<br>
Returns the hour of day of library creation.
</p>
<p>
<b>Creation_Minute</b><br>
int32 Creation_Minute()br>
function Creation_Minute : longint<br>
Returns the minute of hour of library creation.
</p>
<p>
<b>Creation_Month</b><br>
int32 Creation_Month()<br>
function Creation_Month : int32<br>
Returns the month of the year of library creation.
</p>
<p>
<b>Creation_Year</b><br>
int32 Creation_Year()<br>
function Creation_Year : int32<br>
Returns the year of library creation.
</p>
<p>
<b>Delete</b><br>
PUnified_Exception Delete( char* Command )<br>
procedure Delete( Command : string )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Deleted_Space</b><br>
int32 Deleted_Space<br>
function Deleted_Space : int32<br>
Returns the amount of allocated but unused (deleted) space in library file.
</p>
<p>
<b>Extract</b><br>
void Extract( char* Module, char* Filename )<br>
procedure Extract( Module, Filename : string )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Extract_Index</b><br>
int32 Flags<br>
procedure Extract_Index( Module : integer ; Filename : string ; Start_Block : longint )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Get_Last_Error</b><br>
PUnified_Exception Get_Last_Error()<br>
function Get_Last_Error : TSUnified_Exception<br>
Deletes the specified module from the library.
</p>
<p>
<b>Get_Module</b><br>
int32 Flags<br>
procedure Get_Module( Start_Block, X : integer ; var Buffer )<br>
Returns the contents of the module at the specified index and start block.
</p>
<p>
<b>Get_Module_Info_By_Index</b><br>
int32 Flags<br>
function Get_Module_Info( X : integer ; var Info : TModule_Info ) : boolean<br>
Retrieves information on the module at the given index.  Returns false if module
not found.
</p>
<p>
<b>Get_Module_Info_By_Name</b><br>
bool Get_Module_Info_By_Name( char* Command, TModule_Info& Info )<br>
function Get_Module_Info_By_Name( Command : PChar ; var Info : TModule_Info ) : boolean<br>
Retrieves information on the specified module.  Returns false if module not found.
</p>
<p>
<b>Insert</b><br>
PUnified_Exception Insert( char* Command, char* Filename )<br>
procedure Insert( Command, Filename : string )<br>
Inserts the specified file into the library.
</p>
<p>
<b>Modified_Day</b><br>
int32 Modified_Day()<br>
Modified_Day : int32<br>
The day of month of library creation.
</p>
<b>Modified_Hour</b><br>
int Modified_Hour()<br>
Modified_Hour : integer<br>
Hour of day of library creation.
</p>
<p>
<b>Modified_Minute</b><br>
int32 Modified_Minute()<br>
Modified_Minute : longint<br>
Minute of hour of library creation.
</p>
<p>
<b>Modified_Month</b><br>
int32 Modified_Month()<br>
Modified_Month : int32<br>
The month of the year of library creation.
</p>
<p>
<b>Modified_Year</b><br>
int32 Modified_Year()<br>
Modified_Year : int32<br>
The year of library creation.
</p>
<p>
<b>Open</b><br>
PUnified_Exception Open( char* X <br>
procedure Open( X : string )<br>
Opens the specified library file.
</p>
<p>
<b>Size</b><br>
int32 Size()<br>
function Size() : longint<br>
Returns the size of the library, in bytes.
</p>
<p>
<b>Version</b><br>
char* Version()<br>
Version : PChar<br>
The library version.
</p>
