<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TObject_Librarian</b><br>
What: class<br>
Ancestor: <a href="TBase_Delphi_Object.php">TBase_Delphi_Object</a><br>
File: <a href="_Lib.php">_Lib</a><br>
Layer: 1<br>
Platforms: C++, C#, Javascript, Pascal (Delphi), PHP, Python<br>
<br>
Defines information about a module.  It has the following fields and methods (in C++ and
Pascal, the fields are methods, on other platforms, they are fields):
</p>
<p>
<b>Fields:</b><br>
<b>Creation_Day</b><br>
int32 Creation_Day<br>
Creation_Day : int32<br>
The day of month of library creation.
</p>
<p>
<b>Creation_Hour</b><br>
int Creation_Hour<br>
Creation_Hour : integer<br>
Hour of day of library creation.
</p>
<p>
<b>Creation_Minute</b><br>
int32 Creation_Minute<br>
Creation_Minute : longint<br>
Minute of hour of library creation.
</p>
<p>
<b>Creation_Month</b><br>
int32 Creation_Month<br>
Creation_Month : int32<br>
The month of the year of library creation.
</p>
<p>
<b>Creation_Year</b><br>
int32 Creation_Year<br>
Creation_Year : int32<br>
The year of library creation.
</p>
<p>
<b>Deleted_Space</b><br>
int32 Deleted_Space<br>
Deleted_Space : int32<br>
Amount of allocated but unused (deleted) space in library.
</p>
<p>
<b>Modified_Day</b><br>
int32 Modified_Day<br>
Modified_Day : int32<br>
The day of month of library creation.
</p>
<b>Modified_Hour</b><br>
int Modified_Hour<br>
Modified_Hour : integer<br>
Hour of day of library creation.
</p>
<p>
<b>Modified_Minute</b><br>
int32 Modified_Minute<br>
Modified_Minute : longint<br>
Minute of hour of library creation.
</p>
<p>
<b>Modified_Month</b><br>
int32 Modified_Month<br>
Modified_Month : int32<br>
The month of the year of library creation.
</p>
<p>
<b>Modified_Year</b><br>
int32 Modified_Year<br>
Modified_Year : int32<br>
The year of library creation.
</p>
<p>
<b>Version</b><br>
string Version<br>
Version : string<br>
The library version.
</p>

<p>
<b>Methods:</b><br>
<b>Create_New</b><br>
void Create_New( string Command, int32 Language_Id, int32 Typ )<br>
procedure Create_New( Command : String ; Language_Id, Typ : Integer)<br>
Creates a new module with the given specification entry, ID, and type in the library.
</p>
<p>
<b>Delete</b><br>
void Delete( string Command )<br>
procedure Delete( Command : string )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Extract</b><br>
void Extract( string Module, string Filename )<br>
procedure Extract( Module, Filename : string )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Extract_Index</b><br>
void Extract_Index( int32 Module, string Filename, int32 Start_Block )<br>
procedure Extract_Index( Module : integer ; Filename : string ; Start_Block : longint )<br>
Deletes the specified module from the library.
</p>
<p>
<b>Get_Last_Error</b><br>
PSUnified_Exception Get_Last_Error()<br>
function Get_Last_Error : TSUnified_Exception<br>
Deletes the specified module from the library.
</p>
<p>
<b>Get_Module</b><br>
void Get_Module( int32 Start_Block, int32 X, void* Buffer )<br>
procedure Get_Module( Start_Block, X : integer ; var Buffer )<br>
Returns the contents of the module at the specified index and start block.
</p>
<p>
<b>Get_Module_Info</b><br>
bool Get_Module_Info( int32 X, TModule_Info &Info )<br>
function Get_Module_Info( X : integer ; var Info : TModule_Info ) : boolean<br>
Retrieves information on the module at the given index.  Returns false if module
not found.
</p>
<p>
<b>Insert</b><br>
void Insert( string Command, string Filename )<br>
procedure Insert( Command, Filename : string )<br>
Inserts the specified file into the library.
</p>
<p>
<b>Open</b><br>
void Open( string X )<br>
procedure Open( X : string )<br>
Opens the specified library file.
</p>
<p>
<b>Size</b><br>
int32 Size()<br>
function Size() : longint<br>
Returns the size of the library, in bytes.
</p>
