<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSBasic_File</b><br>
What: class<br>
Ancestor: <a href="TCommon_COM_Interface.php">TCommon_COM_Interface</a><br>
File: _COMLists<br>
Layer: 0<br>
Platforms: C++, C#, Pascal (All), PHP, Python<br>
<br>
This class provides a minimal basic file interface suitable for level 0 of the subroutine
library, where the more full-featured file objects are unavailable.  It has the following methods:
</p>
<p>
<b>Close()</b><br>
void Close()<br>
procedure Close()<br>
Closes the open file.
</p>
<p>
<b>EOF</b><br>
bool EOF()<br>
function EOF() : boolean<br>
Returns true if the current file position is at the end of the file.  Returns false
otherwise.  Note: in Python, this always returns False.
</p>
<p>
<b>FileName</b><br>
string FileName()<br>
function FileName : string<br>
Returns the name of the file that was opened.
</p>
<p>
<b>Open</b><br>
int Open( const string Name, int Flags )<br>
function Open( const Name : string ; Flags : integer ) : integer<br>
Opens the specified file.  Flags indicate how the file is opened.
<table>
<tr><th>Value</th><th>Description</th></tr>
<tr><td>FOF_Read_Write<td></td>Open for reading and writing</td></tr>
<tr><td>FOF_Read_Only<td></td>Open for reading only (supercedes FOF_Read_Write)</td></tr>
<tr><td>FOF_Append<td></td>Open and position at end of file</td></tr>
<tr><td>FOF_Must_Exist<td></td>File must exist</td></tr>
<tr><td>FOF_Create<td></td>Create new file/overwrite old file</td></tr>
</table>
The method returns 0 if the file is successfully opened, or one of the following
values:
<table>
<tr><th>Value</th><th>Meaning</th></tr>
<tr><td>FErr_Not_Found</td><td>File does not exist.</td></tr>
</table>
</p>
<p>
<b>ReadLn</b><br>
string ReadLn()<br>
function ReadLn() : string<br>
Returns the next line from the file.
</p>
<p>
<b>WriteLn</b><br>
void WriteLn( const string Value )<br>
procedure WriteLn( const Value : string )<br>
Writes the specified text to the file.
</p>
