<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSCache</b><br>
What: class<br>
File: <a href="_Cache.php">_Cache</a><br>
Ancestor: <a href="TBase_Object.php">TBase_Object</a><br>
Layer: 1<br>
Platforms: C++, C#, Javascript, Pascal (Object), PHP, Python<br>
<br>
Defines a base abstract class for caching.  It contains the following methods:
</p>
<p>
<b>Read_Cache</b><br>
int32 Read_Cache( void* Data, int32 Address, int32 Size )<br>
function Read_Cache( var Data ; Address, Size : longint ) : longint<br>
Reads up to Size bytes from the cache for the specified address.  Returns the number 
of bytes actually read (if 0 then the data was not cached).  Cached data is copied
to Data.
</p>
<p>
<b>Write_Cache</b><br>
void Write_Cache( const void* Data, int32 Address, int32 Size )<br>
procedure Write_Cache( const Data ; Address, Size : longint )<br>
Writes to cache up to Size bytes from Data.
</p>
<p>
<b>Clear</b><br>
void Clear()<br>
procedure Clear<br>
Clears cache.
</p>
<p>
<b>Initialize</b><br>
void Initialize()<br>
procedure Initialize<br>
Initialize object.
</p>
<p>
<b>Terminate</b><br>
void Terminate()<br>
procedure Terminate<br>
Terminate object.
</p>
<p>
<b>Set_Max_Size</b><br>
void Set_Max_Size( int32 Size )<br>
procedure Set_Max_Size( Size : longint )<br>
Sets maximum cache size in bytes.  If this is more than is currently cached, some 
cache is thrown away.
</p>
<p>
<b>Get_Max_Size</b><br>
int32 Get_Max_Size()<br>
function Get_Max_Size : longint<br>
Gets current maximum cache size in bytes.
</p>
<p>
<b>Get_Size</b><br>
int32 Get_Size()<br>
function Get_Size : longint<br>
Returns amount of currently cached data, in bytes.
</p>
<p>
<b>Get_Stats</b><br>
int32 Get_Stats( int32 Index, int32 &Address )<br>
function Get_Stats( Index : longint ; var Address : longint ) : longint<br>
</p>
<p>
<b>Lock</b><br>
bool Lock( int32 Address )<br>
function Lock( Address : longint ) : boolean<br>
Locks the data starting at the specified address into memory so that it is not thrown 
away.  Returns false if the specified data is not in the cache.
</p>
<p>
<b>Unlock</b><br>
bool Unlock( int32 Address )<br>
function Unlock( Address : longint ) : boolean<br>
Unlocks the data starting at the specified address in memory.  Returns false if the 
specified data is not in the cache, or if it is not locked.
</p>
<p>
<b>Get_Hits</b><br>
int32 Get_Hits()<br>
function Get_Hits : longint<br>
Returns the total cache read hits.
</p>
<p>
<b>Get_Misses</b><br>
int32 Get_Misses()<br>
function Get_Misses : longint<br>
Returns the total cache read misses.
</p>
<p>
<b>Get_Writes</b><br>
int32 Get_Writes()<br>
function Get_Writes : longint<br>
Returns the total cache writes.
</p>
<p>
<b>Get_Turns</b><br>
int32 Get_Turns()<br>
function Get_Turns : longint<br>
Returns the number of times that a cached item had to be discarded to make room for
a new item.
</p>
<p>
<b>Get_Replacements</b><br>
int32 Get_Replacements()<br>
function Get_Replacements : longint<br>
Returns the number of writes when the item was already in the cache.
</p>
<p>
<b>Set_Hits</b><br>
void Set_Hits( int32 Value )<br>
procedure Set_Hits( Value : longint )<br>
Sets the total cache read hits.
</p>
<p>
<b>Set_Misses</b><br>
void Set_Misses( int32 Value )<br>
procedure Set_Misses( Value : longint )<br>
Sets the total cache read misses.
</p>
<p>
<b>Set_Writes</b><br>
void Set_Writes( int32 Value ))<br>
procedure Set_Writes( Value : longint )<br>
Sets the total cache writes.
</p>
<p>
<b>Set_Turns</b><br>
void Set_Turns( int32 Value )<br>
procedure Set_Turns( Value : longint )<br>
Sets the number of times that a cached item had to be discarded to make room for
a new item.
</p>
<p>
<b>Set_Replacements</b><br>
void Set_Replacements( int32 Value )<br>
procedure Set_Replacements( Value : longint )<br>
Sets the number of writes when the item was already in the cache.
</p>
<p>
<b>Hits</b><br>
int32 Hits() { return Get_Hits(); }<br>
property Hits : longint read Get_Hits write Set_Hits<br>
Sets the total cache read hits.
</p>
<p>
<b>Misses</b><br>
int32 Misses()  { return Get_Misses(); })<br>
property Misses : longint read Get_Misses write Set_Misses<br>
Sets the total cache read misses.
</p>
<p>
<b>Writes</b><br>
int32 Writes() { return Get_Writes(); }<br>
property Writes : longint read Get_Writes write Set_Writes<br>
Sets the total cache writes.
</p>
<p>
<b>Turns</b><br>
int32 Turns() { return Get_Turns(); }<br>
property Turns : longint read Get_Turns write Set_Turns<br>
Sets the number of times that a cached item had to be discarded to make room for
a new item.
</p>
<p>
<b>Replacements</b><br>
int32 Replacements() { return Get_Replacements(); }<br>
property Replacements : longint read Get_Replacements write Set_Replacements<br>
Sets the number of writes when the item was already in the cache.
</p>
