<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TSStream</b><br>
What: Class<br>
Ancestor: <a href="TDelphi_Object.php">TObject</a><br>
File: _Streams<br>
Layer: 0<br>
Platforms: C++, C#, Javascript, Pascal (All), PHP, Python<br>
<br>
This class is the abstract base class for streams.  The class contains the following methods:
</p>
<p>
<b>At_End</b><br>
bool At_End()<br>
function At_End : boolean<br>
Returns True if there is no more data in the stream to read.
</p>
<p>
<b>Read</b><br>
int32 Read( void* Buffer, int32 _Size )<br>
function Read( var Buffer ; var _Size : longint ) : longint<br>
Reads the specified number of bytes from the stream. Returns the actual bytes transferred 
in _Size.
</p>
<p>
<b>Read_Line</b><br>
void Read_Line( void* Buffer, int32 &_Size )<br>
procedure Read_Line( var Buffer ; var _Size : longint )<br>
Reads one line of input, up to the size of the buffer.
The line is assumed to end at an ASCII 13 code.  The
ASCII 13 code is not included in the returned data.
Size is modified to be the actual bytes transferred.
</p>
<p>
<b>Seek</b><br>
void Seek( int32 Position )<br>
procedure Seek( Position : longint )<br>
Position to specified byte within streamed data.
</p>
<p>
<b>Size</b><br>
int32 Size()<br>
function Size : longint<br>
Returns size of stream data, in bytes.  -1 indicate that
the size is unknown or larger than 2^31.
</p>
<p>
<b>Write</b><br>
int32 Write( void* Buffer, int32 _Size )<br>
procedure Write( var Buffer ; _Size : longint )<br>
Writes the specified buffer, of the specified size in
bytes, to the stream.
</p>
<p>
<b>Write_Line</b><br>
void Write_Line( char* Buffer )<br>
procedure Write_Line( Buffer : PChar )<br>
Writes the specified null-terminated text to the stream.
An ASCII code 13 is appended to the text on output.
</p>
