<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
	<title>C&amp;C Subroutine Library</title>
</head>
<body>
<?php
include "lb_header.php"
?>
<p>
<b>TText_Editor_Interface</b><br>
What: class<br>
Ancestor: <a href="TBase_Delphi_Object.php">TBase_Delphi_Object</a><br>
File: _TE_Interface<br>
Layer: 0<br>
Platforms: C++, C#, Javascript, Pascal (All), PHP, Python<br>
<br>
This abstract base class is used to interface to a text editor.  It has the following methods:
</p>
<p>
<b>Bring_Cursor_Into_View</b><br>
void Bring_Cursor_Into_View()<br>
procedure Bring_Cursor_Into_View<br>
Brings the current cursor position into view.
</p>
<p>
<b>Column_Count</b><br>
int32 Column_Count()<br>
function Column_Count : int32<br>
Returns the width of the viewport.
</p>
<p>
<b>Cursor_Change</b><br>
property Parent : integer read Get_Parent write Set_Parent<br>
(Delphi only)
Access to the Parent handle.
</p>
<p>
<b>Get_Line</b><br>
char* stdcall Get_Line( int32 Row )<br>
function Get_Line( Row : integer ) : PChar<br>
Requests the contents of the specified line.
</p>
<p>
<b>Get_Parent</b><br>
int Get_Parent()<br>
function Get_Parent : integer<br>
Returns the handle of the parent control.
</p>
<p>
<b>Get_Position</b><br>
void Get_Position( int32 &R, int32 &C )<br>
procedure Get_Position( var R, C : int32 )<br>
Returns current cursor position.
</p>
<p>
<b>Get_Selected_Text</b><br>
string Get_Selected_Text()<br>
function Get_Selected_Text : string<br>
Returns the currently selected text.
</p>
<p>
<b>Key_Down</b><br>
void Key_Down( uint16 &Key, int32 Shift )<br>
procedure Key_Down( var Key : Word ; Shift : TShiftState )<br>
send a key-down notice to the editor.
</p>
<p>
<b>Line_Count</b><br>
int32 Line_Count()<br>
function Line_Count : int32<br>
Returns the count of lines in the editor data.
</p>
<p>
<b>Load_File</b><br>
void Load_File( char* Nam )<br>
procedure Load_File( Nam : PChar )<br>
Loads the specified file into the editor.
</p>
<p>
<b>Locate</b><br>
void Locate( string S, int32 &R, int32 &C, bool CS )<br>
procedure Locate( S : string ; var R, C : int32 ; CS : boolean )<br>
Searches the editor contents for the specified string, starting at the specified
row and column.  CS is true to do a case-sensitive search.  Returns the row and column
of the found text (0,0 if not found)
</p>
<p>
<b>Position_To</b><br>
void Position_To( int32 R, int32 C )<br>
procedure Position_To( R, C : int32 )<br>
Change the cursor location, parameters indicate the new cursor position.
</p>
<p>
<b>Save_File</b><br>
void Save_File( char* Nam )<br>
procedure Save_File( Nam : PChar )<br>
Saves the current data to the specified file.
</p>
<p>
<b>Set_Background</b><br>
void Set_Background( int32 Color )<br>
procedure Set_Background( Color : TColor )<br>
Sets the editor background color.
</p>
<p>
<b>Set_Font</b><br>
void Set_Font( char* Name )<br>
procedure Set_Font( Name : PChar )<br>
Sets the font for the editor to use.
</p>
<p>
<b>Set_Font_Size</b><br>
void Set_Font_Size( int32 Siz )<br>
procedure Set_Font_Size( Siz : int32 )<br>
Sets the font size for the editor to use.
</p>
<p>
<b>Set_Foreground</b><br>
void Set_Foreground( int32 Color )<br>
procedure Set_Foreground( Color : TColor )<br>
Sets the editor foreground color.
</p>
<p>
<b>Set_Notifier</b><br>
void Set_Notifier( TText_Editor_Interface_Notifier* V )<br>
procedure Set_Notifier( V : TText_Editor_Interface_Notifier )<br>
Sets instance of notifier.  The editor will send status to this object, if provided.
</p>
<p>
<b>Set_Parent</b><br>
void Set_Parent( int Handle )<br>
procedure Set_Parent( Handle : integer )<br>
Sets the parent.  The parent's handle is passed.
</p>
<p>
<b>Set_Position</b><br>
void Set_Position( TText_Editor_Position P )<br>
procedure Set_Position( P : TText_Editor_Position )<br>
Sets the cursor position.
</p>
<p>
<b>Set_Size</b><br>
void Set_Size( int32 Height, int32 Width )<br>
procedure Set_Size( Height, Width : integer )<br>
Sets the height and width of the viewport.
</p>
<p>
<b>SetFocus</b><br>
void SetFocus()<br>
procedure SetFocus<br>
Notifies editor that it now has focus.
</p>
