/*
		Program Name : Streams
		Package Name : Subroutine Library - Layer 0
		Purpose      : TSStream object
		Institution  : Conroy & Conroy Co.
		Date Written : 2002
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2002-2021 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

#include "Streams.hpp"

// Subroutine Library - Layer 0
#include "_ASCII.hpp" // CR
#include "Typedefs.hpp" // tByte_Array

// TBase_Stream methods...

bool TBase_Stream::At_End()
{
	return true ;
} ;


int32 TBase_Stream::Read( void* Buffer, int32& _Size )
{
	_Size = 0 ;
	return 0 ;
} ;


void TBase_Stream::Read_Line( void* Buffer, int32& _Size )
{
	// Setup...
	int32 Index = 0 ;

	while( !At_End() )
	{
		int32 S = 1 ;
		char C ;
		Read( &C, S ) ;
		if( ( C == CR ) || ( S == 0 ) )
        {
            break ;
		} ;
		((char*) Buffer )[ Index ] = C ;
		Index++ ;
		_Size++ ;
	} ;
} ;


string TBase_Stream::Read_String()
{
	string S = "" ;
	while( !At_End() )
	{
		int Size = 1 ;
		char C;
		Read( &C, Size ) ;
		if( ( C == CR ) || ( Size == 0 ) )
        {
            break ;
        } ;
		S = S + C ;
	} ;
	return S ;
} ;


void TBase_Stream::Seek( int32 Position )
{
} ;


void TBase_Stream::Write( void* Buffer, int32 _Size )
{
} ;


void TBase_Stream::Write_String( const string Buffer )
{
	void* P = (void*)Buffer.c_str() ;
	Write( &P, (int32)Buffer.length() ) ;
} ;


void TBase_Stream::Write_Line( char* Buffer )
{
    Write( Buffer, strlen( Buffer ) ) ;
	char C = CR ;
	Write( &C, 1 ) ;
} ;


void TBase_Stream::Write_Line_String( const string Buffer )
{
	void* P = (void*)Buffer.c_str() ;
	Write( P, (int32)Buffer.length() ) ;
	char C = CR ;
	Write( &C, 1 ) ;
} ;

