/*
        Program Name : Streams
        Package Name : Subroutine Library - Layer 0
        Purpose      : TSStream object
        Institution  : Conroy & Conroy Co.
        Date Written : 2002
        Written By   : Alan Conroy
        Version      : 1.0

      	Copyright (C) 2002-2021 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
		*                                                           *
        *************************************************************
*/

using System;
using _Streams_unit; // TSStream
using _ASCII_unit; // CR

namespace Streams_unit
{
	public class TBase_Stream : TSStream
	{
		// Returns True if there is no more data in the stream to read.
		public override bool At_End()
		{
			return true ;
		}

		/* Reads the specified number of bytes from the stream.
		 Size is modified to be the actual bytes transferred. */
		public int Read( ref string Buffer, ref int _Size )
		{
			_Size = 0 ;
			return 0 ;
		}

		/* Reads one line of input, up to the size of the buffer.
		 The line is assumed to end at an ASCII 13 code.  The
		 ASCII 13 code is not included in the returned data.
		 Size is modified to be the actual bytes transferred. */
		public override void Read_Line( ref string Buffer, ref int _Size )
		{
			// Setup...
			_Size = 0 ;
			string CR = "" + _ASCII.CR ;
			Buffer = "" ;
			while( !At_End() )
			{
				int S = 1 ;
				string C = "" ;
				Read( ref C, ref S ) ;
				if( ( C[ 0 ] == CR[ 0 ] ) || ( S == 0 ) )
				{
					break ;
				} ;
				Buffer = Buffer + C[ 0 ] ;
				_Size++ ;
			} ;
		}

		/* Reads one line of input.  The line is assumed to end at
		 an ASCII 13 code.  The ASCII 13 code is not included in
		 the returned data. */
		public string Read_String()
		{
			string S = "" ;
			while( !At_End() )
			{
				int Size = 1 ;
				string C = "";
				Read( ref C, ref Size ) ;
				if( ( C[ 0 ] == _ASCII.CR ) || ( Size == 0 ) )
				{
					break ;
				} ;
				S = S + C ;
			} ;
			return S ;
		}

		// Position to specified byte within streamed data.
		public override void Seek( int Position )
		{
		}

		/* Writes the specified buffer, of the specified size in
		 bytes, to the stream. */
		public override void Write( ref string Buffer, int _Size )
		{
		}

		// Writes the specified string to the stream.
		public override void Write_String( string Buffer )
		{
			Write( ref Buffer, Buffer.Length ) ;
		}

		/* Writes the specified null-terminated text to the stream.
		 An ASCII code 13 is appended to the text on output. */
		public override void Write_Line( string Buffer )
		{
			Write( ref Buffer, Buffer.Length ) ;
			string C = "" + _ASCII.CR ;
			Write( ref C, 1 ) ;
		}

		/* Writes the specified string to the stream.
		 An ASCII code 13 is appended to the text on output. */
		public override void Write_Line_String( string Buffer )
		{
			Write( ref Buffer, Buffer.Length ) ;
			string C = "" + _ASCII.CR ;
			Write( ref C, 1 ) ;
		}
	} ; // TBase_Stream

	public class PBase_Stream : TBase_Stream
	{
	} ;
}
