/*
        Program Name : _Streams
        Package Name : LB
        Purpose      : TSStream object
        Institution  : Conroy & Conroy Co.
        Date Written : 2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002-2003 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

*/

#ifndef STREAMS_HPP
	#define STREAMS_HPP

#include "eDefines.hpp"

// Subroutine Library - Layer 0...
#include "ComInter.hpp" // TCommon_COM_Object
#include "CommBase.hpp" // TBase_Object
#include "_Streams.hpp" // TSStream
#include <string>

using namespace std;

class TBase_Stream : public TSStream
{
   public: // API...
	  // Returns True if there is no more data in the stream to read.
	  virtual bool At_End() ;

	  // Reads the specified number of bytes from the stream.
	  // Size is modified to be the actual bytes transferred. }
	  virtual int32 Read( void* Buffer, int32& _Size ) ;

	  // Reads one line of input, up to the size of the buffer.
	  // The line is assumed to end at an ASCII 13 code.  The
	  // ASCII 13 code is not included in the returned data.
	  // Size is modified to be the actual bytes transferred.
	  virtual void Read_Line( void* Buffer, int32& _Size ) ;

	  // Reads one line of input.  The line is assumed to end at
	  // an ASCII 13 code.  The ASCII 13 code is not included in
	  // the returned data.
	  virtual string Read_String() ;

	  // Position to specified byte within streamed data.
	  virtual void Seek( int32 Position ) ;

	  // Writes the specified buffer, of the specified size in
	  // bytes, to the stream.
	  virtual void Write( void* Buffer, int32 _Size ) ;

	  // Writes the specified string to the stream.
	  virtual void Write_String( const string Buffer ) ;

	  /* Writes the specified null-terminated text to the stream.
	   An ASCII code 13 is appended to the text on output. */
	  virtual void Write_Line( char* Buffer ) ;

	  /* Writes the specified string to the stream.
		 An ASCII code 13 is appended to the text on output. */
	  virtual void Write_Line_String( const string Buffer ) ;
}; // TBase_Stream

#define PBase_Stream TBase_Stream*

#endif

