#        Program Name : Streams
#        Package Name : Subroutine Library - Layer 0
#        Purpose      : TSStream object
#        Institution  : Conroy & Conroy Co.
#        Date Written : 2002
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#       Copyright (C) 2002-2021 by Alan Conroy.  All rights reserved.
#
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************

from CommBase import * # TBase_Object
from _Streams import * # TSStream
from _ASCII import * # CR

class TBase_Stream( TSStream ):
    # Returns True if there is no more data in the stream to read.
    def At_End():
        return True

    # Reads the specified number of bytes from the stream.
    def Read( _Size ):
        return ""

    # Reads one line of input.
    # The line is assumed to end at an ASCII 13 code.  The
    # ASCII 13 code is not included in the returned data.
    def Read_Line():
        while( not At_End() ):
            C = Read( S )
            if( ( C == CR ) or ( C.Length == 0 ) ):
                break ;
            Buffer = Buffer + C

    # Reads one line of input.  The line is assumed to end at
    # an ASCII 13 code.  The ASCII 13 code is not included in
    # the returned data.
    def Read_String():
        return Read_Line()

    # Position to specified byte within streamed data.
    def Seek( Position ):
        pass

    # Writes the specified buffer, of the specified size in
    # bytes, to the stream.
    def Write( Buffer, _Size ):
        pass
    
    # Writes the specified string to the stream.
    def Write_String( Buffer ):
        Write( Buffer, length( Buffer ) )

    # Writes the specified null-terminated text to the stream.
    # An ASCII code 13 is appended to the text on output.
    def Write_Line( Buffer ):
        Write( Buffer, strlen( Buffer ) )
        C = CR
        Write( C, 1 )

    # Writes the specified string to the stream.
    # An ASCII code 13 is appended to the text on output. }
    def Write_Line_String( Buffer ):
        Write( Buffer, length( Buffer ) )
        C = CR
        Write( C, 1 ) ;

class PBase_Stream( TBase_Stream ):
    pass
