{$V-}
{
        Program Name : Collect
        Package Name : Subroutine Library - Layer 0
        Purpose      : Test TCollection
        Institution  : Conroy & Conroy Co.
        Date Written : 03-Jul-1996
	      Last Modified: 17-May-2002
        Written By   : Alan Conroy
        Version      : 2.0A

        Copyright 2021 by Alan Conroy.  Released to the public domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides the TCollection definition to reduce the
        differences between the various versions of Borland Pascal/Delphi.  This
        is not in Compatib beecause of unit dependancy issues.  It also provides
        some other TCollection variants.
}

unit Test__Collect ;

interface


implementation

uses Collect ;

procedure TCollection_Test ;

var Loop : integer ;
    TC : TCollection ;

begin
    TC.Init( 0, 0 ) ;
    if( TC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if(  TC.IndexOf( pointer( 1 ) ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
         TC.Insert( pointer( Loop * 2 ) ) ;
    end ;
    if(  TC.Count() <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if(  TC.At( Loop ) <> pointer( Loop * 2 ) ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
         TC.AtPut( Loop, pointer( Loop * 2 + 1 ) ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if(  TC.At( Loop ) <> pointer( Loop * 2 + 1 ) ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if(  TC.Indexof( pointer( 3 ) ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
     TC.Delete( pointer( 3 ) ) ;
    if(  TC.Indexof( pointer( 3 ) ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := TC.Count() - 1 downto 0 do
    begin
         TC.AtDelete( Loop ) ;
    end ;
    if(  TC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if(  TC.At( -1 ) <> nil ) then
    begin
        writeln( 'At( -1 ) did not return 0' ) ;
        halt ;
    end ;
end ;


procedure TString_Collection_Test ;

var Loop : integer ;
    TSC : TString_Collection ;

    function itos( X : integer ) : string ;

    var S : string ;

    begin
        str( X, S ) ;
        itos := S ;
    end ;

begin
    TSC.Init( 0, 0 ) ;
    if( TSC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( TSC.IndexOf( '1' ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        TSC.Insert( itos( Loop * 2 ) ) ;
    end ;
    if( TSC.Count() <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( TSC.At( Loop ) <> itos( Loop * 2 ) ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
        TSC.AtPut( Loop, itos( Loop * 2 + 1 ) ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( TSC.At( Loop ) <> itos( Loop * 2 + 1 ) ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if( TSC.Indexof( '3' ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
    TSC.Delete( '3' ) ;
    if( TSC.Indexof( '3' ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := TSC.Count() - 1 downto 0 do
    begin
        TSC.AtDelete( Loop ) ;
    end ;
    if( TSC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( TSC.At( -1 ) <> '' ) then
    begin
        writeln( 'At( -1 ) did not return null string' ) ;
        halt ;
    end ;
end ;


procedure TInteger_Collection_Test ;

var Loop : integer ;
    TC : TInteger_Collection ;

begin
    TC.Init( 0, 0 ) ;
    if( TC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( TC.IndexOf( 1 ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        TC.Insert( Loop * 2 ) ;
    end ;
    if( TC.Count() <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( TC.At( Loop ) <> Loop * 2 ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
        TC.AtPut( Loop, Loop * 2 + 1 ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( TC.At( Loop ) <> Loop * 2 + 1 ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if( TC.Indexof( 3 ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
    TC.Delete( 3 ) ;
    if( TC.Indexof( 3 ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := TC.Count() - 1 downto 0 do
    begin
        TC.AtDelete( Loop ) ;
    end ;
    if( TC.Count() <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( TC.At( -1 ) <> 0 ) then
    begin
        writeln( 'At( -1 ) did not return 0' ) ;
        halt ;
    end ;
end ;


begin
    TCollection_Test ;
    TString_Collection_Test ;
    TInteger_Collection_Test ;
end.
