{
        Program Name : Test__CommBase
        Package Name : Subroutine Library - Layer 0
        Purpose      : Common base objects (TBase_Object and TBase_Delphi_Object)
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Mar-2002
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2002-2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Test__CommBase ;

interface

{$I EDEFINES.INC}

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

uses { C&C... }
     CommBase ;


implementation

{$IFDEF DYNAMIC_OBJECTS}
procedure TBase_Delphi_Object_Test ;

var I : integer ;
    T : TBase_Delphi_Object ;

begin
    T := TBase_Delphi_Object.Create ;
    I := T.Reference_Count ;
    T.Attach ;
    if( I + 1 <> T.Reference_Count ) then
    begin
        writeln( 'Attach failed' ) ;
    end ;
    if( I = 0 ) then { No previous attachments }
    begin
        T.Attach ;
        inc( I ) ;
    end ;
    T.Detach ;
    if( I <> T.Reference_Count ) then
    begin
        writeln( 'Detach failed' ) ;
    end ;
    T.Free ;
end ;
{$ENDIF}


procedure TBase_Object_Test ;

var I : integer ;
    T : TBase_Object ;

begin
    T.Init ;
    I := T.Reference_Count ;
    T.Attach ;
    if( I + 1 <> T.Reference_Count ) then
    begin
        writeln( 'Attach failed' ) ;
    end ;
    if( I = 0 ) then { No previous attachments }
    begin
        T.Attach ;
        inc( I ) ;
    end ;
    T.Detach ;
    if( I <> T.Reference_Count ) then
    begin
        writeln( 'Detach failed' ) ;
    end ;
    T.Done ;
end ;



begin
{$IFDEF DYNAMIC_OBJECTS}
    TBase_Delphi_Object_Test ;
{$ENDIF}

    TBase_Object_Test ;
end.

