{
        Program Name : L10N
        Package Name : LB
        Purpose      : Localization for LB
        Institution  : Conroy & Conroy Co.
        Date Written : 23-August-2010
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2010 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit provides for localization of the text used in LB.
}

unit Test__L10n ;

interface

implementation

uses L10N ;

begin
    if( Text_Error_Expected_Equal <> 'Expected equal' ) then
    begin
        writeln( 'Mismatched function' ) ;
        halt ;
    end ;
    if( Substitute( '$1 is $1 and $1', 'XYZZY', '$1' ) <> 'XYZZY is XYZZY and XYZZY' ) then
    begin
        writeln( 'Substitution failure' ) ;
        halt ;
    end ;
    if( Substitute( '$1 is $1 and $1', 'XYZZY$1', '$1' ) <> 'XYZZY$1 is $1 and $1' ) then
    begin
        writeln( 'Substitution failure' ) ;
        halt ;
    end ;
    if( Substitute1( '"$1"', 'XYZZY' ) <> '"XYZZY"' ) then
    begin
        writeln( 'Substitution failure' ) ;
        halt ;
    end ;
    if( Substitute2( '"$1"$2', 'XYZZY', 'PLUGH' ) <> '"XYZZY"PLUGH' ) then
    begin
        writeln( 'Substitution failure' ) ;
        halt ;
    end ;
    if( Substitute3( '"$1"$2-$$3', 'XYZZY', 'PLUGH', 'BEDQUILT' ) <> '"XYZZY"PLUGH-$BEDQUILT' ) then
    begin
        writeln( 'Substitution failure' ) ;
        halt ;
    end ;
    Load_Text( 'c:\lb\Test__L10n.txt' ) ;
    if( Get_Text( 0, 'XYZZY' ) <> 'Substitute message 1' ) then
    begin
        writeln('Load_Text failed') ;
        halt ;
    end ;
    Load_Text( 'c:\lb\Test__L10n.txt' ) ;
    if( Get_Text( 0, 'XYZZY' ) <> 'Substitute message 1' ) then
    begin
        writeln('Load_File failed') ;
        halt ;
    end ;
    if( Get_Text( 10, 'XYZZY' ) <> 'XYZZY' ) then
    begin
        writeln('Get_Text failed') ;
        halt ;
    end ;
    Load_Text( 'c:\\.txt' ) ;
    if( Get_Text( 0, 'XYZZY' ) <> 'Substitute message 1' ) then
    begin
        writeln('Load_Text failed') ;
        halt ;
    end ;
end.
