/*
		Program Name : _AEL
		Package Name : Subroutine Library - Layer 1
		Purpose      : Abstract Application Event Logger
		Institution  : Conroy & Conroy Co.
		Date Written : 31-January-2003
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2003-2021 by Alan Conroy.  Released to the Public Domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************

		  The classes in this unit are used to provide an OO event logging
	interface.
*/

#ifndef _AEL_HPP
	#define _AEL_HPP

#include "eDefines.hpp"

#include "CommBase.hpp" // TBase_Object
#include "ComInter.hpp" // TCommon_COM_Interface
#include "_DebugIn.hpp" // PDebug_Interface
#include "_Types.hpp" // Ansistring
#include <string>

class TApplication_Event_Logger : public TBase_Delphi_Object
{
	public:// API...
		virtual void Log_Event( const string S ) = 0 ;
		virtual void Trace_Enter( const string S ) = 0 ;
		virtual void Trace_Exit( const string S ) = 0 ;
} ;

#ifdef STDCALL_SUPPORTED
class TCOM_Application_Event_Logger : public TCommon_COM_Interface
{
	public: // API...
		virtual stdcall void Log_Event( char* S ) = 0 ;
		virtual stdcall void Trace_Enter( char* S ) = 0 ;
		virtual stdcall void Trace_Exit( char* S ) = 0 ;
} ;
#endif

class TSApplication_Event_Logger : public TBase_Object
{
	public: // API...
		virtual PSDebug_Interface Debugger() ;
		virtual void Log_Event( const string S ) ;
		virtual void Trace_Enter( const string S ) ;
		virtual void Trace_Exit( const string S ) ;
} ;

#define PSApplication_Event_Logger TSApplication_Event_Logger*

#endif

