using System;

namespace _ASCII_unit
{
	public class _ASCII
	{
		/*
					  Program Name : _ASCII
					  Package Name : Subroutine Library - layer 0
					  Purpose      : Definitions of ASCII constants
					  Institution  : Conroy & Conroy Co.
					  Date Written : 23-Apr-1995
					  Written By   : Alan Conroy
					  Version      : 1.0A

					  Copyright (c) 1995-2004 by Alan Conroy.  Released to the public domain.

				  TO THE GLORY OF GOD THROUGH JESUS CHRIST

				*********************************************************
				*                                                       *
				*        M O D I F I C A T I O N   H I S T O R Y        *
				*                                                       *
				*********************************************************

					 DATE      BY             REASON

				19-Nov-2015    EAC            Added additional constants.

				*********************************************************
				*                                                       *
				*           P R O G R A M   P U R P O S E               *
				*                                                       *
				*********************************************************

				Support for ASCII values, including character and numeric constants.

				*********************************************************
				*                                                       *
				*            F I L E   D E S C R I P T I O N S          *
				*                                                       *
				*********************************************************
		*/

		public const char NUL = '\0' ; // Null
		public const char SOH = '\x0001' ; // Start Of Heading
		public const char STX = '\x0002' ; // Start Text
		public const char ETX = '\x0003' ; // End Text
		public const char EOT = '\x0004' ; // End Of Transmission
		public const char ENQ = '\x0005' ; // Enquiry
		public const char ACK = '\x0004' ; // Acknowledge
		public const char BEL = '\x0007' ; // Bell
		public const char BS = '\x0008' ; // Backspace
		public const char HT = '\x0009' ; // Horizontal Tab
		public const char LF = '\x000A' ; // Line Feed
		public const char VT = '\x000B' ; // Vertical Tab
		public const char FF = '\x000C' ; // Form Feed
		public const char CR = '\x000D' ; // Carriage return
		public const char SO = '\x000E' ; // Shift Out
		public const char SI = '\x000F' ; // Shift In
		public const char DLE = '\x0010' ; // Data Link Escape
		public const char DC1 = '\x0011' ; // Direct Control 1
		  public const char XON = DC1 ; // Transmission On
		public const char DC2 = '\x0012' ; // Direct Control 2
		public const char DC3 = '\x0013' ; // Direct Control 3
		  public const char XOFF = DC3 ; // Transmission Off
		public const char DC4 = '\x0014' ; // Direct Control 4
		public const char NAK = '\x0015' ; // Negative Acknowledge
		public const char SYN = '\x0016' ; // Synchronous idle
		public const char ETB = '\x0017' ; // End Tranmission Block
		public const char CAN = '\x0018' ; // Cancel
		public const char EM = '\x0019' ; // End of Medium
		public const char SUB = '\x001A' ; // Substitute
		public const char ESC = '\x001B' ; // Escape
		public const char Escape = '\x001B' ; // Ditto
		public const char FS = '\x001C' ; // Form separator
		public const char GS = '\x001D' ; // Group separator
		public const char RS = '\x001E' ; // Record separator
		public const char US = '\x001F' ; // Unit separator
		public const char Space = ' ' ;
		public const char SP = ' ' ; // Space
		public const char DEL = '\x007F' ; // Delete

		// DEC supplemental codes...
		public const char IND = '\x0084' ;
		public const char NEL = '\x0085' ;
		public const char SSA = '\x0086' ;
		public const char ESA = '\x0087' ;
		public const char HTS = '\x0088' ;
		public const char HTJ = '\x0089' ;
		public const char VTS = '\x008A' ;
		public const char PLD = '\x008B' ;
		public const char PLU = '\x008C' ;
		public const char RI = '\x008D' ;
		public const char SS2 = '\x008E' ;
		public const char SS3 = '\x008F' ;
		public const char DCS = '\x0090' ;
		public const char PU1 = '\x0091' ;
		public const char PU2 = '\x0092' ;
		public const char STS = '\x0093' ;
		public const char CCH = '\x0094' ;
		public const char MW = '\x0095' ;
		public const char SPA = '\x0096' ;
		public const char EPA = '\x0097' ;
		public const char CSI = '\x009B' ;
		public const char ST = '\x009C' ;
		public const char OSC = '\x009D' ;
		public const char PM = '\x009E' ;
		public const char APC = '\x009F' ;
		public const char NBSP = '\x00A0' ;

		// Used by SMU...
		public const char EBS = '\x00FE' ; // Extended backspace

		// Combination codes...
		public const string CRLF = "\x000D\x000A" ; // CR and LF

		public const char Control_A = '\x0001' ; // Start Of Heading
		public const char Control_B = '\x0002' ; // Start Text
		public const char Control_C = '\x0003' ; // End Text
		public const char Control_D = '\x0004' ; // End Of Transmission
		public const char Control_E = '\x0005' ; // Enquiry
		public const char Control_F = '\x0006' ; // Acknowledge
		public const char Control_G = '\x0007' ; // Bell
		public const char Control_H = '\x0008' ; // Backspace
		public const char Control_I = '\x0009' ; // Horizontal Tab
		public const char Control_J = '\x000A' ; // Line Feed
		public const char Control_K = '\x000B' ; // Vertical Tab
		public const char Control_L = '\x000C' ; // Form Feed
		public const char Control_M = '\x000D' ; // Carriage return
		public const char Control_N = '\x000E' ; // Shift Out
		public const char Control_O = '\x000F' ; // Shift In
		public const char Control_P = '\x0010' ; // Data Link Escape
		public const char Control_Q = '\x0011' ; // Direct Control 1
		public const char Control_R = '\x0012' ; // Direct Control 2
		public const char Control_S = '\x0013' ; // Direct Control 3
		public const char Control_T = '\x0014' ; // Direct Control 4
		public const char Control_U = '\x0015' ; // Negative Acknowledge
		public const char Control_V = '\x0016' ; // Synchronous idle
		public const char Control_W = '\x0017' ; // End Tranmission Block
		public const char Control_X = '\x0018' ; // Cancel
		public const char Control_Y = '\x0019' ; // End of Medium
		public const char Control_Z = '\x001A' ; // Substitute

		public const int _NUL = 0 ; // Null
		public const int _SOH = 1 ; // Start Of Heading
		public const int _STX = 2 ; // Start Text
		public const int _ETX = 3 ; // End Text
		public const int _EOT = 4 ; // End Of Transmission
		public const int _ENQ = 5 ; // Enquiry
		public const int _ACK = 6 ; // Acknowledge
		public const int _BEL = 7 ; // Bell
		public const int _BS = 8 ; // Backspace
		public const int _HT = 9 ; // Horizontal Tab
		public const int _LF = 10 ; // Line Feed
		public const int _VT = 11 ; // Vertical Tab
		public const int _FF = 12 ; // Form Feed
		public const int _CR = 13 ; // Carriage return
		public const int _SO = 14 ; // Shift Out
		public const int _SI = 15 ; // Shift In
		public const int _DLE = 16 ; // Data Link Escape
		public const int _DC1 = 17 ; // Direct Control 1
		  public const int _XON = _DC1 ; // Transmission On
		public const int _DC2 = 18 ; // Direct Control 2
		public const int _DC3 = 19 ; // Direct Control 3
		  public const int _XOFF = _DC3 ; // Transmission On
		public const int _DC4 = 20 ; // Direct Control 4
		public const int _NAK = 21 ; // Negative Acknowledge
		public const int _SYN = 22 ; // Synchronous idle
		public const int _ETB = 23 ; // End Tranmission Block
		public const int _CAN = 24 ; // Cancel
		public const int _EM = 25 ; // End of Medium
		public const int _SUB = 26 ; // Substitute
		public const int _ESC = 27 ; // Escape
		public const int _Escape = 27 ; // Ditto
		public const int _FS = 28 ; // Form separator
		public const int _GS = 29 ; // Group separator
		public const int _RS = 30 ; // Record separator
		public const int _US = 31 ; // Unit separator
		public const int _Space = 32 ;
		public const int _SP = 32 ; // Space
		public const int _DEL = 127 ; // Delete
		public const int _CRLF = ( _LF << 8 ) | _CR ;

		// DEC supplemental codes...
		public const int _IND = 132 ;
		public const int _NEL = 133 ;
		public const int _SSA = 134 ;
		public const int _ESA = 135 ;
		public const int _HTS = 136 ;
		public const int _HTJ = 137 ;
		public const int _VTS = 138 ;
		public const int _PLD = 139 ;
		public const int _PLU = 140 ;
		public const int _RI = 141 ;
		public const int _SS2 = 142 ;
		public const int _SS3 = 143 ;
		public const int _DCS = 144 ;
		public const int _PU1 = 145 ;
		public const int _PU2 = 146 ;
		public const int _STS = 147 ;
		public const int _CCH = 148 ;
		public const int _MW = 149 ;
		public const int _SPA = 150 ;
		public const int _EPA = 151 ;
		public const int _CSI = 155 ;
		public const int _ST = 156 ;
		public const int _OSC = 157 ;
		public const int _PM = 158 ;
		public const int _APC = 159 ;
		public const int _NBSP = 160 ;

		// Used by SMU...
		public const int _EBS = 254 ; // Extended backspace

		public const int _Control_A = 1 ; // Start Of Heading
		public const int _Control_B = 2 ; // Start Text
		public const int _Control_C = 3 ; // End Text
		public const int _Control_D = 4 ; // End Of Transmission
		public const int _Control_E = 5 ; // Enquiry
		public const int _Control_F = 6 ; // Acknowledge
		public const int _Control_G = 7 ; // Bell
		public const int _Control_H = 8 ; // Backspace
		public const int _Control_I = 9 ; // Horizontal Tab
		public const int _Control_J = 10 ; // Line Feed
		public const int _Control_K = 11 ; // Vertical Tab
		public const int _Control_L = 12 ; // Form Feed
		public const int _Control_M = 13 ; // Carriage return
		public const int _Control_N = 14 ; // Shift Out
		public const int _Control_O = 15 ; // Shift In
		public const int _Control_P = 16 ; // Data Link Escape
		public const int _Control_Q = 17 ; // Direct Control 1
		public const int _Control_R = 18 ; // Direct Control 2
		public const int _Control_S = 19 ; // Direct Control 3
		public const int _Control_T = 20 ; // Direct Control 4
		public const int _Control_U = 21 ; // Negative Acknowledge
		public const int _Control_V = 22 ; // Synchronous idle
		public const int _Control_W = 23 ; // End Tranmission Block
		public const int _Control_X = 24 ; // Cancel
		public const int _Control_Y = 25 ; // End of Medium
		public const int _Control_Z = 26 ; // Substitute
	}
}
