const NUL = String.fromCharCode( 0 ) ; // Null
const SOH = String.fromCharCode(1) ; // Start Of Heading
const STX = String.fromCharCode(2) ; // Start Text
const ETX = String.fromCharCode(3) ; // End Text
const EOT = String.fromCharCode(4) ; // End Of Transmission
const ENQ = String.fromCharCode(5) ; // Enquiry
const ACK = String.fromCharCode(6) ; // Acknowledge
const BEL = String.fromCharCode(7) ; // Bell
const BS = String.fromCharCode(8) ; // Backspace
const HT = String.fromCharCode(9) ; // Horizontal Tab
const LF = String.fromCharCode(10) ; // Line Feed
const VT = String.fromCharCode(11) ; // Vertical Tab
const FF = String.fromCharCode(12) ; // Form Feed
const CR = String.fromCharCode(13) ; // Carriage return
const SO = String.fromCharCode(14) ; // Shift Out
const SI = String.fromCharCode(15) ; // Shift In
const DLE = String.fromCharCode(16) ; // Data Link Escape
const DC1 = String.fromCharCode(17) ; // Direct Control 1
const DC2 = String.fromCharCode(18) ; // Direct Control 2
const DC3 = String.fromCharCode(19) ; // Direct Control 3
const DC4 = String.fromCharCode(20) ; // Direct Control 4
const NAK = String.fromCharCode(21) ; // Negative Acknowledge
const SYN = String.fromCharCode(22) ; // Synchronous idle
const ETB = String.fromCharCode(23) ; // End Tranmission Block
const CAN = String.fromCharCode(24) ; // Cancel
const EM = String.fromCharCode(25) ; // End of Medium
const SUB = String.fromCharCode(26) ; // Substitute
const ESC = String.fromCharCode(27) ; // Escape
const Escape = String.fromCharCode(27) ; // Ditto
const FS = String.fromCharCode(28) ; // Form separator
const GS = String.fromCharCode(29) ; // Group separator
const RS = String.fromCharCode(30) ; // Record separator
const US = String.fromCharCode(31) ; // Unit separator
const Space = String.fromCharCode(32) ;
const SP = String.fromCharCode(32) ; // Space
const DEL = String.fromCharCode(127) ; // Delete

// DEC supplemental codes...
const IND = String.fromCharCode(132) ;
const NEL = String.fromCharCode(133) ;
const SSA = String.fromCharCode(134) ;
const ESA = String.fromCharCode(135) ;
const HTS = String.fromCharCode(136) ;
const HTJ = String.fromCharCode(137) ;
const VTS = String.fromCharCode(138) ;
const PLD = String.fromCharCode(139) ;
const PLU = String.fromCharCode(140) ;
const RI = String.fromCharCode(141) ;
const SS2 = String.fromCharCode(142) ;
const SS3 = String.fromCharCode(143) ;
const DCS = String.fromCharCode(144) ;
const PU1 = String.fromCharCode(145) ;
const PU2 = String.fromCharCode(146) ;
const STS = String.fromCharCode(147) ;
const CCH = String.fromCharCode(148) ;
const MW = String.fromCharCode(149) ;
const SPA = String.fromCharCode(150) ;
const EPA = String.fromCharCode(151) ;
const CSI = String.fromCharCode(155) ;
const ST = String.fromCharCode(156) ;
const OSC = String.fromCharCode(157) ;
const PM = String.fromCharCode(158) ;
const APC = String.fromCharCode(159) ;
const NBSP = String.fromCharCode(160) ;

// Used by SMU...
const EBS = String.fromCharCode(254) ; // Extended backspace

// Combination codes...
const CRLF = String.fromCharCode(13,10) ; // CR and LF

const Control_A = String.fromCharCode(1) ; // Start Of Heading
const Control_B = String.fromCharCode(2) ; // Start Text
const Control_C = String.fromCharCode(3) ; // End Text
const Control_D = String.fromCharCode(4) ; // End Of Transmission
const Control_E = String.fromCharCode(5) ; // Enquiry
const Control_F = String.fromCharCode(6) ; // Acknowledge
const Control_G = String.fromCharCode(7) ; // Bell
const Control_H = String.fromCharCode(8) ; // Backspace
const Control_I = String.fromCharCode(9) ; // Horizontal Tab
const Control_J = String.fromCharCode(10) ; // Line Feed
const Control_K = String.fromCharCode(11) ; // Vertical Tab
const Control_L = String.fromCharCode(12) ; // Form Feed
const Control_M = String.fromCharCode(13) ; // Carriage return
const Control_N = String.fromCharCode(14) ; // Shift Out
const Control_O = String.fromCharCode(15) ; // Shift In
const Control_P = String.fromCharCode(16) ; // Data Link Escape
const Control_Q = String.fromCharCode(17) ; // Direct Control 1
const Control_R = String.fromCharCode(18) ; // Direct Control 2
const Control_S = String.fromCharCode(19) ; // Direct Control 3
const Control_T = String.fromCharCode(20) ; // Direct Control 4
const Control_U = String.fromCharCode(21) ; // Negative Acknowledge
const Control_V = String.fromCharCode(22) ; // Synchronous idle
const Control_W = String.fromCharCode(23) ; // End Tranmission Block
const Control_X = String.fromCharCode(24) ; // Cancel
const Control_Y = String.fromCharCode(25) ; // End of Medium
const Control_Z = String.fromCharCode(26) ; // Substitute

const _NUL = 0 ; // Null
const _SOH = 1 ; // Start Of Heading
const _STX = 2 ; // Start Text
const _ETX = 3 ; // End Text
const _EOT = 4 ; // End Of Transmission
const _ENQ = 5 ; // Enquiry
const _ACK = 6 ; // Acknowledge
const _BEL = 7 ; // Bell
const _BS = 8 ; // Backspace
const _HT = 9 ; // Horizontal Tab
const _LF = 10 ; // Line Feed
const _VT = 11 ; // Vertical Tab
const _FF = 12 ; // Form Feed
const _CR = 13 ; // Carriage return
const _SO = 14 ; // Shift Out
const _SI = 15 ; // Shift In
const _DLE = 16 ; // Data Link Escape
const _DC1 = 17 ; // Direct Control 1
const _DC2 = 18 ; // Direct Control 2
const _DC3 = 19 ; // Direct Control 3
const _DC4 = 20 ; // Direct Control 4
const _NAK = 21 ; // Negative Acknowledge
const _SYN = 22 ; // Synchronous idle
const _ETB = 23 ; // End Tranmission Block
const _CAN = 24 ; // Cancel
const _EM = 25 ; // End of Medium
const _SUB = 26 ; // Substitute
const _ESC = 27 ; // Escape
const _Escape = 27 ; // Ditto
const _FS = 28 ; // Form separator
const _GS = 29 ; // Group separator
const _RS = 30 ; // Record separator
const _US = 31 ; // Unit separator
const _Space = 32 ;
const _SP = 32 ; // Space
const _DEL = 127 ; // Delete

// DEC supplemental codes...
const _IND = 132 ;
const _NEL = 133 ;
const _SSA = 134 ;
const _ESA = 135 ;
const _HTS = 136 ;
const _HTJ = 137 ;
const _VTS = 138 ;
const _PLD = 139 ;
const _PLU = 140 ;
const _RI = 141 ;
const _SS2 = 142 ;
const _SS3 = 143 ;
const _DCS = 144 ;
const _PU1 = 145 ;
const _PU2 = 146 ;
const _STS = 147 ;
const _CCH = 148 ;
const _MW = 149 ;
const _SPA = 150 ;
const _EPA = 151 ;
const _CSI = 155 ;
const _ST = 156 ;
const _OSC = 157 ;
const _PM = 158 ;
const _APC = 159 ;
const _NBSP = 160 ;

// Used by SMU...
const _EBS = 254 ; // Extended backspace

const _Control_A = 1 ; // Start Of Heading
const _Control_B = 2 ; // Start Text
const _Control_C = 3 ; // End Text
const _Control_D = 4 ; // End Of Transmission
const _Control_E = 5 ; // Enquiry
const _Control_F = 6 ; // Acknowledge
const _Control_G = 7 ; // Bell
const _Control_H = 8 ; // Backspace
const _Control_I = 9 ; // Horizontal Tab
const _Control_J = 10 ; // Line Feed
const _Control_K = 11 ; // Vertical Tab
const _Control_L = 12 ; // Form Feed
const _Control_M = 13 ; // Carriage return
const _Control_N = 14 ; // Shift Out
const _Control_O = 15 ; // Shift In
const _Control_P = 16 ; // Data Link Escape
const _Control_Q = 17 ; // Direct Control 1
const _Control_R = 18 ; // Direct Control 2
const _Control_S = 19 ; // Direct Control 3
const _Control_T = 20 ; // Direct Control 4
const _Control_U = 21 ; // Negative Acknowledge
const _Control_V = 22 ; // Synchronous idle
const _Control_W = 23 ; // End Tranmission Block
const _Control_X = 24 ; // Cancel
const _Control_Y = 25 ; // End of Medium
const _Control_Z = 26 ; // Substitute
