/*
		Program Name : _COMLists
		Package Name : Subroutine Library Layer 0
		Purpose      : COM list abstract class
		Institution  : Conroy & Conroy Co.
		Date Written : 1-Nov-2006
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2006-2021 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

#ifndef _COMLISTS_HPP
	#define _COMLISTS_HPP

#include "eDefines.hpp"

// C&C Subroutine Library - Layer 0...
#include "COMInter.hpp"


class TCOM_List: public TCommon_COM_Interface
{
	 public: // API...
		 virtual int32 stdcall Add( int32 Value ) = 0 ;
		 virtual int32 stdcall Get_Count() = 0 ;
		 virtual void stdcall Set_Count( int32 Value ) = 0 ;
		 virtual int32 stdcall Get_Capacity() = 0 ;
		 virtual void stdcall Set_Capacity( int32 Value ) = 0 ;
		 virtual int32 stdcall Get_Item( int32 Index ) = 0 ;
		 virtual void stdcall Set_Item( int32 Index, int32 Value ) = 0 ;
		 virtual int32 stdcall Get_Delta() = 0 ;
		 virtual void stdcall Set_Delta( int32 Value ) = 0 ;
		 virtual int32 stdcall IndexOf( int32 Value ) = 0 ;

	 public: // Property handlers...
		 virtual int64 _Get_Item( int64 Index ) {return Get_Item(Index);};
		 virtual void _Set_Item( int64 Index, int64 Value ) {Set_Item(Index, Value);};
		 virtual int32 _Get_Count() {return Get_Count();};
		 virtual void _Set_Count( int32 Value ) {Set_Count(Value);};
		 virtual int32 _Get_Capacity() {return Get_Capacity();};
		 virtual void _Set_Capacity( int32 Value ) {Set_Capacity(Value);};
		 virtual int32 _Get_Delta() {return Get_Delta();};
		 virtual void _Set_Delta( int32 Value ) {Set_Delta(Value);};

		 virtual int64 Items( int64 Index ) {return _Get_Item(Index);};

	 public: // Properties...
		 virtual int32 Capacity() {return _Get_Capacity();};
		 virtual int32 Count() {return _Get_Count();};
		 virtual int32 Delta() {return _Get_Delta();};
} ;



#endif

