/*
        Program Name : _Cache
        Package Name : Subroutine Library - Layer 1
        Purpose      : Cache class definition
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Jun-1994
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1994-2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
		*************************************************************

          This unit defines classes for handling caches.
*/

#include "_Cache.hpp"

// TSCache methods...

TSCache::TSCache()
{
	Statistics.Hits = 0 ;
	Statistics.Misses = 0 ;
	Statistics.Writes = 0 ;
	Statistics.Turns = 0 ;
	Statistics.Replacements = 0 ;
} ;


// API...

int32 TSCache::Read_Cache( void* Data, int32 Address, int32 Size )
{
	Abstract_Error() ;
	return 0 ;
} ;


void TSCache::Write_Cache( const void* Data, int32 Address, int32 Size )
{
	Abstract_Error() ;
} ;


void TSCache::Clear()
{
    Abstract_Error() ;
} ;


void TSCache::Initialize()
{
    Abstract_Error() ;
} ;


void TSCache::Terminate()
{
    Abstract_Error() ;
} ;


void TSCache::Set_Max_Size( int32 Size )
{
    Abstract_Error() ;
} ;


int32 TSCache::Get_Max_Size()
{
	Abstract_Error() ;
	return 0 ;
} ;


int32 TSCache::Get_Size()
{
	Abstract_Error() ;
	return 0 ;
} ;


int32 TSCache::Get_Stats( int32 Index, int32& Address )
{
	Abstract_Error() ;
	return 0 ;
} ;


bool TSCache::Lock( int32 Address )
{
	Abstract_Error() ;
	return false ;
} ;


bool TSCache::Unlock( int32 Address )
{
	Abstract_Error() ;
	return false ;
} ;


int32 TSCache::Get_Hits()
{
	return Statistics.Hits ;
} ;


int32 TSCache::Get_Misses()
{
	return Statistics.Misses ;
} ;


int32 TSCache::Get_Writes()
{
	return Statistics.Writes ;
} ;


int32 TSCache::Get_Turns()
{
	return Statistics.Turns ;
} ;


int32 TSCache::Get_Replacements()
{
	return Statistics.Replacements ;
} ;


void TSCache::Set_Hits( int32 Value )
{
	Statistics.Replacements = Value ;
} ;


void TSCache::Set_Misses( int32 Value )
{
	Statistics.Misses = Value ;
} ;


void TSCache::Set_Writes( int32 Value )
{
	Statistics.Writes = Value ;
} ;


void TSCache::Set_Turns( int32 Value )
{
	Statistics.Turns = Value ;
} ;


void TSCache::Set_Replacements( int32 Value )
{
	Statistics.Replacements = Value ;
} ;



// TSCache64 methods...

// API...

TSCache64::TSCache64()
{
	Statistics.Hits = 0 ;
	Statistics.Misses = 0 ;
	Statistics.Writes = 0 ;
	Statistics.Turns = 0 ;
	Statistics.Replacements = 0 ;
} ;


int64 TSCache64::Read_Cache( void* Data, int64 Address, int64 Size )
{
	Abstract_Error() ;
	return 0 ;
} ;


void TSCache64::Write_Cache( const void* Data, int64 Address, int64 Size )
{
    Abstract_Error() ;
} ;


void TSCache64::Clear()
{
    Abstract_Error() ;
} ;


void TSCache64::Initialize()
{
    Abstract_Error() ;
} ;


void TSCache64::Terminate()
{
    Abstract_Error() ;
} ;


void TSCache64::Set_Max_Size( int32 Size )
{
    Abstract_Error() ;
} ;


int32 TSCache64::Get_Max_Size()
{
	Abstract_Error() ;
	return 0 ;
} ;


int32 TSCache64::Get_Size()
{
	Abstract_Error() ;
	return 0 ;
} ;


int32 TSCache64::Get_Stats( int32 Index, int64& Address )
{
	Abstract_Error() ;
	return 0 ;
} ;


bool TSCache64::Lock( int64 Address )
{
	Abstract_Error() ;
	return false ;
} ;


bool TSCache64::Unlock( int64 Address )
{
	Abstract_Error() ;
	return false ;
} ;


int32 TSCache64::Get_Hits()
{
	return Statistics.Hits ;
} ;


int32 TSCache64::Get_Misses()
{
	return Statistics.Misses ;
} ;


int32 TSCache64::Get_Writes()
{
	return Statistics.Writes ;
} ;


int32 TSCache64::Get_Turns()
{
	return Statistics.Turns ;
} ;


int32 TSCache64::Get_Replacements()
{
	return Statistics.Replacements ;
} ;


void TSCache64::Set_Hits( int32 Value )
{
	Statistics.Replacements = Value ;
} ;


void TSCache64::Set_Misses( int32 Value )
{
	Statistics.Misses = Value ;
} ;


void TSCache64::Set_Writes( int32 Value )
{
	Statistics.Writes = Value ;
} ;


void TSCache64::Set_Turns( int32 Value )
{
	Statistics.Turns = Value ;
} ;


void TSCache64::Set_Replacements( int32 Value )
{
	Statistics.Replacements = Value ;
} ;

