class TCache_Statistics
{
	var Hits = 0 ; // Total read hits
	var Misses = 0 ; // Read misses
	// Note: Hits + Misses = total reads
	var Writes = 0 ; // Total writes
	var Turns = 0 ; // Number of times blocks were thrown away to make room for more
	var Replacements = 0 ; // Number of write hits
	// Note: Write - Replacements = non-replacement writes
} ;


class TCache extends TBase_Object
{
	var Statistics = new TCache_Statistics() ;

	// API...

	Read_Cache( Data, Address, Size )
	{
		Abstract_Error() ;
		return 0 ;
	}


	Write_Cache( Data, Address, Size )
	{
		Abstract_Error() ;
	}


	Clear()
	{
    	Abstract_Error() ;
	}


	Initialize()
	{
    	Abstract_Error() ;
	}


	Terminate()
	{
    	Abstract_Error() ;
	}


	Set_Max_Size( Size )
	{
    	Abstract_Error() ;
	}


	Get_Max_Size()
	{
		Abstract_Error() ;
		return 0 ;
	}


	Get_Size()
	{
		Abstract_Error() ;
		return 0 ;
	}


	Get_Stats( Index, &Address )
	{
		Abstract_Error() ;
		return 0 ;
	}


	Lock( Address )
	{
		Abstract_Error() ;
		return false ;
	}


	Unlock( Address )
	{
		Abstract_Error() ;
		return false ;
	}


	Get_Hits()
	{
		return this.Statistics.Hits ;
	}


	Get_Misses()
	{
		return this.Statistics.Misses ;
	}


	Get_Writes()
	{
	return this.Statistics.Writes ;
	}


	Get_Turns()
	{
		return this.Statistics.Turns ;
	}


	Get_Replacements()
	{
		return this.Statistics.Replacements ;
	}


	Set_Hits( Value )
	{
		this.Statistics.Replacements = Value ;
	}


	Set_Misses( Value )
	{
		this.Statistics.Misses = Value ;
	}


	Set_Writes( Value )
	{
		this.Statistics.Writes = Value ;
	}


	Set_Turns( Value )
	{
		this.Statistics.Turns = Value ;
	}


	Set_Replacements( Value )
	{
		this.Statistics.Replacements = Value ;
	}
} ;


class TSCache extends TCache
{
} ;


class PSCache64 extends TSCache
{
} ;


class TSCache64 extends PSCache
{
} ;


class PSCache64 extends TSCache64
{
} ;
