<?php
 /*
        Program Name : _Cache
        Package Name : Subroutine Library - Layer 1
        Purpose      : Cache class definition
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Jun-1994
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1994-2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
		*************************************************************

          This unit defines classes for handling caches.
*/

require_once "CommBase.php" ;
require_once "_Types.php" ;

class TCache_Statistics
{
	public $Hits = 0 ; // Total read hits
	public $Misses = 0 ; // Read misses
	// Note: Hits + Misses = total reads
	public $Writes = 0 ; // Total writes
	public $Turns = 0 ; // Number of times blocks were thrown away to make room for more
	public $Replacements = 0 ; // Number of write hits
	// Note: Write - Replacements = non-replacement writes
} ;


class TCache extends TBase_Object
{
	public $Statistics ;

	public function __construct()
	{
		$this->$Statistics = new TCache_Statistics() ;
	}

	// API...

	public function Read_Cache( $Data, $Address, $Size )
	{
		Abstract_Error() ;
		return 0 ;
	}


	public function Write_Cache( $Data, $Address, $Size )
	{
		Abstract_Error() ;
	}


	public function Clear()
	{
    	Abstract_Error() ;
	}


	public function Initialize()
	{
    	Abstract_Error() ;
	}


	public function Terminate()
	{
    	Abstract_Error() ;
	}


	public function Set_Max_Size( $Size )
	{
    	Abstract_Error() ;
	}


	public function Get_Max_Size()
	{
		Abstract_Error() ;
		return 0 ;
	}


	public function Get_Size()
	{
		Abstract_Error() ;
		return 0 ;
	}


	public function Get_Stats( $Index, &$Address )
	{
		Abstract_Error() ;
		return 0 ;
	}


	public function Lock( $Address )
	{
		Abstract_Error() ;
		return false ;
	}


	public function Unlock( $Address )
	{
		Abstract_Error() ;
		return false ;
	}


	public function Get_Hits()
	{
		return $this->$Statistics->$Hits ;
	}


	public function Get_Misses()
	{
		return $this->$Statistics->$Misses ;
	}


	public function Get_Writes()
	{
	return $this->$Statistics->$Writes ;
	}


	public function Get_Turns()
	{
		return $this->$Statistics->$Turns ;
	}


	public function Get_Replacements()
	{
		return $this->$Statistics->$Replacements ;
	}


	public function Set_Hits( $Value )
	{
		$this->$Statistics->$Replacements = $Value ;
	}


	public function Set_Misses( $Value )
	{
		$this->$Statistics->$Misses = $Value ;
	}


	public function Set_Writes( $Value )
	{
		$this->$Statistics->$Writes = $Value ;
	}


	public function Set_Turns( $Value )
	{
		$this->$Statistics->$Turns = $Value ;
	}


	public function Set_Replacements( $Value )
	{
		$this->$Statistics->$Replacements = $Value ;
	}
} ;


class TSCache extends TCache
{
} ;


class PSCache64 extends TSCache
{
} ;


class TSCache64 extends PSCache
{
} ;


class PSCache64 extends TSCache64
{
} ;
