#        Program Name : _Cache
#        Package Name : Subroutine Library - Layer 1
#        Purpose      : Cache class definition
#        Institution  : Conroy & Conroy Co.
#        Date Written : 18-Jun-1994
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#        Copyright (C) 1994-2021 by Alan Conroy.  Released to the public domain.
#
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON                         
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************
#
#          This unit defines classes for handling caches.

from CommBase import  * # TBase_Object
from _Types import * # int64
from _Common import * # Abstract_Error

class TCache_Statistics():
    Hits = 0 # Total read hits
    Misses = 0 # Read misses
    # Note: Hits + Misses = total reads
    Writes = 0 # Total writes
    Turns = 0 # Number of times blocks were thrown away to make room for more
    Replacements = 0 # Number of write hits
    # Note: Write - Replacements = non-replacement writes

class TCache( TBase_Object ):
    Statistics = TCache_Statistics()

    def Read_Cache( Data, Address, Size ):
        # Reads up to Size bytes from the cache for the specified
        #  address.  Returns the number of bytes actually read (if
        #  0 then the data was not cached).  Cached data is copied to Data.
        Abstract_Error()
        return 0

    def Write_Cache( Data, Address, Size ):
        # Writes to cache up to Size bytes from Data.
        Abstract_Error()

    def Clear(): # Clears cache
        Abstract_Error()

    def Initialize(): # Initialize object
        Abstract_Error()

    def Terminate(): # Terminate object
        Abstract_Error()

    def Set_Max_Size( Size ):
        # Sets maximum cache size in bytes.  If this is more
        # than is currently cached, some cache is thrown away.
        Abstract_Error()

    def Get_Max_Size(): # Gets current maximum cache size in bytes.
        Abstract_Error()
        return 0

    def Get_Size(): # Returns amount of currently cached data, in bytes.
        Abstract_Error()
        return 0

    def Get_Stats( Index, Address ):
        Abstract_Error()
        return 0

    def Lock( Address ):
        # Locks the data starting at the specified address into
        # memory so that it is not thrown away.  Returns false if
        # the specified data is not in the cache.
        Abstract_Error()
        return False

    def Unlock( Address ):
        # Unlocks the data starting at the specified address in
        # memory.  Returns false if the specified data is not in
        # the cache, or if it is not locked.
        Abstract_Error()
        return False

    def Get_Hits(): # Total read hits
        return Statistics.Hits

    def Get_Misses(): # Read misses
        return Statistics.Misses

    def Get_Writes(): # Total writes
        return Statistics.Wrwites

    def Get_Turns(): # Number of times blocks were thrown away to make room for more
        return Statistics.Turns

    def Get_Replacements(): # Number of write hits
        return Statistics.Replacements

    def Set_Hits( Value ): # Total read hits
        Statistics.Hits = Value

    def Set_Misses( Value ): # Read misses
        Statistics.Misses = Value

    def Set_Writes( Value ): # Total writes
        Statistics.Writes = Value

    def Set_Turns( Value ): # Number of times blocks were thrown away to make room for more
        Statistics.Turns = Value

    def Set_Replacements( Value ): # Number of write hits
        Statistics.Replacements = Value

class TSCache( TCache ):
    pass
    
class PSCache( TSCache ):
    pass

class TSCache64( PSCache ):
    pass

class PSCache64( TSCache64):
    pass
