/*
        Program Name : _CacheMa
        Package Name : Subroutine Library - Layer 1
        Purpose      : Cache Manager class
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Jun-1994
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1994-2008 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
		*        P R O G R A M   P U R P O S E                      *
        *                                                           *
		*************************************************************

		  The cache manager is used to manage multiple caches.
*/

#ifndef _CACHEMA.HPP
	#define _CACHEMA.HPP

#include "eDefines.hpp"

#include "_Cache.hpp" // PSCache
#include "CommBase.hpp" // TBase_Object

class TSCache_Manager : public TBase_Object
{
	public: // API...
		virtual void Initialize() ;
		virtual void Terminate() ;
		virtual void Add( PSCache Routine, int32 Priority ) ;
		/* This routine adds a cache handler to the cache
		 chain.  Routine is a pointer to the cache
		 handler and Priority is the relative priority of this cache. */

		virtual void Delete( PSCache Routine ) ;
		// This routine removes a cache handler from the cache handler list.

		virtual void Free_Cache( int32 Siz, int32 Priority, PSCache Exclude ) ;
		/* This routine calls the appropriate cache
		 handlers to free up Siz bytes of memory.  A
		 specific handler can be excluded from this.
		 Calling this with Exclude of nil, priority of
		 maxint, and Siz of -1, will zero all caches. */
} ;
#define PSCache_Manager TSCache_Manager*

PSCache_Manager Cache_Manager() ;

#endif

