/*
        Program Name : _Common
        Package Name : Subroutine Library - Layer 0
        Purpose      : Common base objects (TObject and TDelphi_Object)
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Mar-2002
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2005-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

           DATE        BY          REASON                         

        1-Nov-2002     EAC         Removed pointless overrides of
                                   TObject methods in BP.  Added
                                   reference counting support.

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************
*/

#include "_Common.hpp"
#include <string>
#include <iostream>

using namespace std;

/* Unit API... */

void Abstract_Error()
{
    throw "Call to abstract method" ;
} ;


/* TObject methods... */

TObject::TObject()
{
#ifdef CC_Debug
    Sanity = "TObject";
#endif
} ;


void TObject::Attach()
{
#ifdef CC_Debug
    if( Sanity != "TObject" )
    {
        cout << "Invalid object" ;
    } ;
#endif
    Abstract_Error() ;
} ;


bool TObject::Detach()
{
#ifdef CC_Debug
    if( Sanity != "TObject" )
    {
        cout << "Invalid object" ;
    } ;
#endif
	Abstract_Error() ;
	return false ;
} ;


string TObject::Classname()
{
#ifdef CC_Debug
    if( Sanity != "TObject" ) 
    {
        cout << "Invalid object" ;
    } ;
#endif
    return "TObject" ;
} ;


bool TObject::Is_Class( const string Name )
{
#ifdef CC_Debug
    if( Sanity != "TObject" )
    {
        cout << "Invalid object" ;
    } ;
#endif
    return ( Name == Classname() ) ;
} ;


TMemory_Type TObject::Get_Memory_Type()
{
    return MT_Unknown ;
} ;
