/*
		Program Name : _Common
		Package Name : Subroutine Library - Layer 0
		Purpose      : Common base objects (TObject and TDelphi_Object)
		Institution  : Conroy & Conroy Co.
		Date Written : 19-Mar-2002
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

		   DATE        BY          REASON

		1-Nov-2002     EAC         Removed pointless overrides of
								   TObject methods in BP.  Added
								   reference counting support.

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

using System;

namespace _Common_unit
{
	public class _Common
	{
		public enum TMemory_Type
		{
			MT_Unknown, // Don't know
			MT_Heap, // Allocated on heap
			MT_Data, // "Global" data
			MT_Stack, // "Local" data
			MT_Code // executable
		} ;

		public void Abstract_Error()
		{
			throw new Exception("Call to abstract method");
		}
	} ;


	public abstract class TDelphi_Object
	{
		public abstract void Attach() ;
		public abstract bool Detach() ;
		public abstract bool Is_Class( string Name ) ;
	} ;


	public class TObject
	{
		public _Common.TMemory_Type Get_Memory_Type()
		{
			return _Common.TMemory_Type.MT_Unknown ;
		}


		public virtual void Attach()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}


		public virtual bool Detach()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return false ;
		}


		public virtual string Classname()
		{
			return "TObject" ;
		}


		public virtual bool Is_Class( string Name )
		{
			return ( Name == Classname() ) ;
		}
	} ;


	public class PObject : TObject
	{
	} ;
}
