/*
        Program Name : _Deferred
        Package Name : Subroutine Library
        Purpose      : Deferred execution support
        Institution  : Conroy & Conroy Co.
        Date Written : 20-Jun-2015
        Written By   : Alan Conroy
        Version      : 1.0

		Copyright (C) 2015-2021 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

        The TDeferred_Execution class is used to queue up "packets" of code for
        later execution.
*/

using System;
using Collect_unit;
using ASCIIDef_unit;

namespace _Deferred_unit
{
	public abstract class TDeferred_Execution
	{
		public abstract void Execute( IntPtr Context ) ;
	} ;

	public abstract class TDeferred_Manager
	{
		public abstract void Add( TDeferred_Execution Item, IntPtr Context ) ;
		public abstract void Remove( TDeferred_Execution Item, IntPtr Context ) ;
		public abstract void Remove_All( TDeferred_Execution Item ) ;
		public abstract void Execute_Next() ;
		public abstract int Index_Of( TDeferred_Execution Item, IntPtr Context ) ;
		public abstract int Index_Of_First( TDeferred_Execution Item ) ;
		public abstract bool Is_Empty() ;
	} ;

	public class _Deferred
	{
		TDeferred_Manager Deferred_Manager = null ;
	}
}

