/*
        Program Name : _Deferred
        Package Name : Subroutine Library
        Purpose      : Deferred execution support
        Institution  : Conroy & Conroy Co.
        Date Written : 20-Jun-2015
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2015 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

        The TDeferred_Execution class is used to queue up "packets" of code for
        later execution.
*/

#ifndef _DEFERRED_HPP
		#define _DEFERRED_HPP

class TDeferred_Execution
{
	public:
		virtual void Execute( void* Context ) = 0 ;
} ;

class TDeferred_Manager
{
	public:
		virtual void Add( TDeferred_Execution Item, void* Context ) = 0 ;
		virtual void Remove( TDeferred_Execution Item, void* Context ) = 0 ;
		virtual void Remove_All( TDeferred_Execution Item ) = 0 ;
		virtual void Execute_Next() = 0 ;
		virtual int Index_Of( TDeferred_Execution Item, void* Context ) = 0 ;
		virtual int Index_Of_First( TDeferred_Execution Item ) = 0 ;
		virtual bool Is_Empty() = 0 ;
} ;

TDeferred_Manager* Deferred_Manager = NULL ;

#endif

