/*
        Program Name : Events
        Package Name : Subroutine library - layer 1
        Purpose      : Abstract base class for events
        Institution  : Conroy & Conroy Co.
        Date Written : 18-July-2004
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2004 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TSEvent is the base class for event objects which are used to pass
        event notifications between objects.
*/

#ifndef _EVENTS_HPP
	#define _EVENTS_HPP

#include "eDefines.hpp"

#include "CommBase.hpp" // TObject

#include <string>

using namespace std;

const EID_Windows_Key_Down = 1 ; // Key downpress
const EID_Windows_Mouse_LButton_Click = 2 ; // Mouse left-button click
const EID_Windows_Resize = 3 ; // Size/resize

class TSGeneric_Event : public TBase_Object
{
	public:
		void* Source ; // Source (object) of event
		bool User ; // True if directly a user-generated event (such as a keystroke)
		int32 Event_Type ; // Unique ID for event

		virtual string Name() ; // Name of event
} ;

#define PSGeneric_Event TSGeneric_Event*

class TGeneric_Event : public TBase_Delphi_Object
{
	public:
		void* Source ; // Source (object) of event
		bool User ; // True if directly a user-generated event (such as a keystroke)
		int32 Event_Type ; // Unique ID for event

		virtual string Name() = 0 ; // Name of event
} ;

#endif

