#        Program Name : Events
#        Package Name : Subroutine library - layer 1
#        Purpose      : Abstract base class for events
#        Institution  : Conroy & Conroy Co.
#        Date Written : 18-July-2004
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#	    Copyright (C) 2004 by Alan Conroy.  All rights reserved.
#
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON                         
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************
#
#          TSEvent is the base class for event objects which are used to pass
#        event notifications between objects.

from CommBase import * # TObject

EID_Windows_Key_Down = 1 # Key downpress
EID_Windows_Mouse_LButton_Click = 2 # Mouse left-button click
EID_Windows_Resize = 3 # Size/resize

class TGeneric_Event( TBase_Object ):
    Source = None # Source (object) of event
    User = False # True if directly a user-generated event (such as a keystroke)
    Event_Type = 0 # Unique ID for event

    def Name(): # Name of event
        return "Abstract TSGeneric_Event"

class TSGeneric_Event( TGeneric_Event ):
    pass

class PSGeneric_Event( TSGeneric_Event ):
    pass
