/*
        Program Name : _Fonts
        Package Name : Subroutine Library - layer 1
        Purpose      : Font characteristics class
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

		Copyright (C) 2009-2021 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
		*************************************************************
*/

using System;
using CommBase_unit ; // TBase_Delphi_Object

namespace _Fonts_unit
{
	public class TRect
	{
		public int Left ;
		public int Top ;
		public int Right ;
		public int Bottom ;
	}


	public abstract class TFont : TBase_Delphi_Object
	{
		public abstract string Get_Name() ;
		public abstract int Get_Italic_Amount() ;
		public abstract int Get_Bold_Amount() ;
		public abstract bool Get_Italic() ;
		public abstract bool Get_Bold() ;
		public abstract int Get_Size() ;
		public abstract void Set_Name( string Value ) ;
		public abstract void Set_Italic_Amount( int Value ) ;
		public abstract void Set_Bold_Amount( int Value ) ;
		public abstract void Set_Italic( bool Value ) ;
		public abstract void Set_Bold( bool Value ) ;
		public abstract void Set_Size( int Value ) ;

		public abstract int Baseline() ; // Above baseline is ascent, below is descent
		public abstract int Leading() ; // Internal leading
		public abstract void Draw( int Canvas, TRect Rect, int _Baseline, string Value ) ;

		// Properties...
		public int Size
		{
			get { return Get_Size(); }
			set { Set_Size( value ); }
		}
		public int Italic_Amount
		{
			get { return Get_Italic_Amount(); }
			set { Set_Italic_Amount( value ); }
		}
		public int Bold_Amount
		{
			get { return Get_Bold_Amount(); }
			set { Set_Bold_Amount( value ); }
		}
		public bool Italic
		{
			get { return Get_Italic(); }
			set { Set_Italic( value ); }
		}
		public bool Bold
		{
			get { return Get_Bold(); }
			set { Set_Bold( value ); }
		}
	} ; // TFont
}
