/*
        Program Name : _Fonts
        Package Name : Subroutine Library - layer 1
        Purpose      : Font characteristics class
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

		Copyright (C) 2009-2021 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
		*************************************************************
*/

#ifndef _FONTS_HPP
	#define _FONTS_HPP

#include "CommBase.hpp" // TBase_Delphi_Object

#include <string>

using namespace std;

class TRect
{
	int32 Left ;
	int32 Top ;
	int32 Right ;
	int32 Bottom ;
} ;


class TFont : public TBase_Delphi_Object
{
	public:
		virtual string Get_Name() = 0 ;
		virtual int32 Get_Italic_Amount() ;
		virtual int32 Get_Bold_Amount() = 0 ;
		virtual bool Get_Italic() = 0 ;
		virtual bool Get_Bold() = 0 ;
		virtual int32 Get_Size() = 0 ;
		virtual void Set_Name( string Value ) = 0 ;
		virtual void Set_Italic_Amount( int32 Value ) = 0 ;
		virtual void Set_Bold_Amount( int32 Value ) = 0 ;
		virtual void Set_Italic( bool Value ) = 0 ;
		virtual void Set_Bold( bool Value ) = 0 ;
		virtual void Set_Size( int32 Value ) = 0 ;

		virtual int32 Baseline() = 0 ; // Above baseline is ascent, below is descent
		virtual int32 Leading() = 0 ; // Internal leading
		virtual void Draw( int Canvas, TRect Rect, int32 _Baseline, string Value ) = 0 ;

		// Properties...
		int32 Size()
		{
			return Get_Size();
		}
		int32 Italic_Amount()
		{
			return Get_Italic_Amount();
		}
		int32 Bold_Amount()
		{
			return Get_Bold_Amount();
		}
		bool Italic()
		{
			return Get_Italic();
		}
		bool Bold()
		{
			return Get_Bold();
		}
} ; // TFont

#endif

