// TData_Type_Family
const DTF_Unknown = 0 ; // Variant
const DTF_Undefined = 1 ; // Binary
const DTF_Logical = 2 ;
const DTF_Numeric = 3 ;
const DTF_Character = 4 ; // Character/string
const DTF_Pointer = 5 ; // pointer/method/procedure/function
const DTF_Composite = 6 ;
const DTF_Collection = 7 ;
const DTF_User_Defined = 8 ;
const DTF_Meta = 9 ; // Type
const DTF_Other = 10 ;

// TValue_Data_Type
const VDT_Empty = 0 ;
const VDT_Null = 1 ;
const VDT_Boolean = 2 ;
const VDT_Integer = 3 ;
const VDT_Real = 4 ;
const VDT_String = 5 ;
const VDT_Char = 6 ;
const VDT_Pointer = 7 ;
const VDT_Value = 8 ; // TGeneric_Value defining a type
const VDT_Code = 9 ; // Function or procedure
const VDT_Scalar = 10 ;
const VDT_User_Defined = 11 ;
const VDT_Unknown = 12 ;

// TCall_Mechanism
const CM_By_Value = 0 ;
const CM_By_Reference = 1 ;
const CM_By_Name = 2 ;

// TMethod_Class
const MC_Private = 0 ;
const MC_Protected = 1 ;
const MC_Public = 2 ;
const MC_Published = 3 ;


class TSGeneric_Parameter extends TObject
{
	Typ()
	{
   	    Abstract_Error() ;
    	return NULL;
	}


	Output()
	{
	    Abstract_Error() ;
	    return false;
	}


	Constant()
	{
	    Abstract_Error() ;
	    return true;
	}


	Mechanism()
	{
	    Abstract_Error() ;
	    return CM_By_Value;
	}


	_Default()
	{
	    Abstract_Error() ;
	    return NULL;
	}
} // TSGeneric_Parameter


class TSGeneric_Number extends TObject
{
	Fixed()
	{
	    Abstract_Error() ;
	    return true;
	}


	Signed()
	{
	    Abstract_Error() ;
	    return true;
	}


	Mantissa_Size()
	{
	    Abstract_Error() ;
	    return 0;
	} 


	Exponent_Size()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Fractional_Size()
	{
	    Abstract_Error() ;
	    return 0;
	}
} // TSGeneric_Number


class TSGeneric_Character extends TObject
{
	Max_Length()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Fixed()
	{
	    Abstract_Error() ;
	    return true;
	}


	Length()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Logical_Length()
	{
	    Abstract_Error() ;
	    return 0;
	}
} // TSGeneric_Character


class TSGeneric_Collection extends TObject
{
	Fixed()
	{
	    Abstract_Error() ;
	    return true;
	}


	Sparse()
	{
	    Abstract_Error() ;
	    return false;
	}


	Subscripts()
	{
	    Abstract_Error() ;
	    return 0;
	}


	High_Bound( Subscript )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Low_Bound( Subscript ) 
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Get_Subscript( Address ) 
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Row_Major()
	{
	    Abstract_Error() ;
	    return true;
	}
} // TSGeneric_Collection


class TSGeneric_Composite extends TObject
{
	Ancestor( index )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Ancestor_Count()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Ancestor_Class( Index )
	{
	    Abstract_Error() ;
	    return MC_Private;
	}


	Count()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Get_Item( Index ) 
	{
	    Abstract_Error() ;
	    return NULL;
	}
} // TSGeneric_Composite


class TSGeneric_Method extends TObject
{
	Is_Abstract()
	{
	    Abstract_Error() ;
	    return false;
	}


	Is_Constructor()
	{
	    Abstract_Error() ;
	    return false;
	}


	Is_Destructor()
	{
	    Abstract_Error() ;
	    return false;
	}


	Is_Virtual()
	{
	    Abstract_Error() ;
	    return false;
	}


	_Static()
	{
	    Abstract_Error() ;
	    return false;
	}


	C_Order()
	{
	    Abstract_Error() ;
	    return false;
	}


	Standard()
	{
	    Abstract_Error() ;
	    return true;
	}


	Execute( Parameters ) 
	{
   	 Abstract_Error() ;
   	 return NULL;
	}


	Compile_Time()
	{
	    Abstract_Error() ;
	    return false;
	}


	Count()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Max_Count()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Parameter( Index )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Target()
	{
	    Abstract_Error() ;
	    return false;
	}


	Method_Class()
	{
	    Abstract_Error();
		return MC_Public;
	}
} // TSGeneric_Method


class TSProperty_Information extends TObject
{
	
	Getter()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Setter()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	_Default()
	{
	    Abstract_Error() ;
	    return false;
	}
}


class TSType_Information extends TObject
{
	Is_Composite()
	{
	    Abstract_Error() ;
	    return false;
	}


	Is_Collection()
	{
	    Abstract_Error() ;
	    return false;
	}


	Memory_Type()
	{
	    Abstract_Error() ;
	    return MT_Unknown;
	}


	Parameter()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Numeric_Information()
	{
   		Abstract_Error() ;
   		return NULL;
	}


	Character_Information()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Composite_Information()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Collection_Information()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	fMethod()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	_Property()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Address()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Range_Limited()
	{
	    Abstract_Error() ;
	    return false;
	}


	Low_Range()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	High_Range()
	{
	   	Abstract_Error() ;
	    return NULL;
	}


	Value_Name( Value )
	{
	    Abstract_Error() ;
		return "";
	}
} // TSType_Information


class TSGeneric_Value extends TObject
{
	Family() 
	{
	    Abstract_Error() ;
	    return DTF_Unknown;
	}


	Data_Type()
	{
	    Abstract_Error() ;
	    return VDT_Unknown;
	}


	User_Data_Type_Name()
	{
	    Abstract_Error() ;
	    return "";
	}


	Name() // Variable, type, method, or parameter name
	{
	    Abstract_Error() ;
	    return "";
	}


	Type_Information()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Constant()
	{
	    Abstract_Error() ;
	    return true;
	}


	Size() // Size in bytes
	{
	    Abstract_Error() ;
	    return 0;
	}


	Total_Size()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Dereference()
	{
	    Abstract_Error() ;
		return NULL;
	}


	Can_Convert( Typ )
	{
	    Abstract_Error() ;
	    return false;
	}


	Convert( Class_Type, Loss )
	{
	    Abstract_Error() ;
	    return NULL;
	}


	_Clone()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Simple_Cast( Typ )
	{
	    Abstract_Error() ;
	}


	Cast( Typ )
	{
	    Abstract_Error() ;
	}


	Deserialize( Value )
	{
	    Abstract_Error() ;
	}


	Serialize()
	{
	    Abstract_Error() ;
	    return NULL;
	}


	Set_Null()
	{
   		Abstract_Error() ;
	}


	Get_Undefined( Buffer, Len )
	{
	    Abstract_Error() ;
	}


	Set_Undefined( Buffer, Len )
	{
	    Abstract_Error() ;
	}


	Get_Boolean()
	{
	    Abstract_Error() ;
	    return false;
	}


	Set_Boolean( B )
	{
	    Abstract_Error() ;
	}


	Get_ByteBool()
	{
	    Abstract_Error() ;
	    return false;
	}


	Set_ByteBool( B )
	{
	    Abstract_Error() ;
	}


	Get_WordBool()
	{
	    Abstract_Error() ;
	    return false;
	}


	Set_WordBool( B )
	{
	    Abstract_Error() ;
	}


	Get_LongBool()
	{
	    Abstract_Error() ;
	    return false;
	}


	Set_LongBool( B )
	{
	    Abstract_Error() ;
	}


	Get_Char()
	{
	    Abstract_Error() ;
	    return '\0';
	}


	Set_Char( C )
	{
	    Abstract_Error() ;
	}


	Get_String()
	{
	    Abstract_Error() ;
	    return "";
	}


	Set_String( S )
	{
	   	Abstract_Error() ;
	}


	Get_PChar()
	{
	   	Abstract_Error() ;
	   	return NULL;
	}


	Set_PChar( P )
	{
	    Abstract_Error() ;
	}


	Get_Integer8()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Integer8( I )
	{
	    Abstract_Error() ;
	}


	Get_Integer16()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Integer16( I )
	{
	    Abstract_Error() ;
	}


	Get_Integer32()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Integer32( I )
	{
	    Abstract_Error() ;
	}


	Get_Integer64()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Integer64( I )
	{
	    Abstract_Error() ;
	}


	Get_Unsigned_Integer8()
	{
	   	Abstract_Error() ;
	   	return 0;
	}


	Set_Unsigned_Integer8( I )
	{
	    Abstract_Error() ;
	}


	Get_Unsigned_Integer16()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Unsigned_Integer16( I )
	{
	    Abstract_Error() ;
	}


	Get_Unsigned_Integer32()
	{
	    Abstract_Error() ;
	    return 0;
	}


	Set_Unsigned_Integer32( I )
	{
	    Abstract_Error() ;
	}


	Get_Single()
	{
	   	Abstract_Error() ;
	    return 0.0;
	}


	Set_Single( S )
	{
	    Abstract_Error() ;
	}


	Get_Double()
	{
	    Abstract_Error() ;
	    return 0.0;
	}


	Set_Double( D )
	{
	    Abstract_Error() ;
	}


	Get_Extended()
	{
	    Abstract_Error() ;
	    return 0.0;
	}


	Set_Extended( E )
	{
	    Abstract_Error() ;
	}
} // TSGeneric_Value
