/*
		Program Name : _Lib
		Package Name : Subroutine Library - Layer 1
		Purpose      : Abstract Object Librarian class definitions
		Institution  : Conroy & Conroy Co.
		Date Written : 15-Dec-1988
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 1988-2021 by Alan Conroy.  Released to the public domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*********************************************************
		*                                                       *
		*        M O D I F I C A T I O N   H I S T O R Y        *
		*                                                       *
		*********************************************************

			 DATE      BY             REASON

		*********************************************************
		*                                                       *
		*           P R O G R A M   P U R P O S E               *
		*                                                       *
		*********************************************************

		*********************************************************
		*                                                       *
		*            F I L E   D E S C R I P T I O N S          *
		*                                                       *
		*********************************************************
*/

using System;
using CommBase_unit; // TBase_Object
using _Common_unit; // TObject
using _UE_unit; // TUnified_Exception

namespace _Lib_unit
{
	public class _Lib
	{
		public const int LibErr_Facility = 14 ;
		public const int LibErr_Success = 0 ;
		public const int LibErr_Invalid_Library_File_Format = 1 ;
		public const int LibErr_Module_Not_Found = 2 ;
		public const int LibErr_Module_Already_Exists = 3 ;
		public const int LibErr_Illegal_Module_Format = 4 ;
	} ;


	public class TModule_Info
	{
		public string[] Name ;
		public int Size ;
		int Day ;
		int Month ;
		int Year ;
		int Hour ;
		int Minute ;
		int Flags ;
	} ;

	public abstract class TObject_Librarian : TObject
	{
		// Instance data...
		public int Creation_Hour ;
		public int Creation_Minute ;
		public int Creation_Day ;
		public int Creation_Month ;
		public int Creation_Year ;
		public int Deleted_Space ;
		public int Modified_Hour ;
		public int Modified_Minute ;
		public int Modified_Day ;
		public int Modified_Month ;
		public int Modified_Year ;
		public string Version ;

		// API...
		public abstract void Create_New( string Command, int Language_Id, int Typ ) ;
		public abstract TUnified_Exception Get_Last_Error() ;
		public abstract void Extract( string Module, string Filename ) ;
		public abstract	void Extract_Index( int Module, string Filename, int Start_Block ) ;
		public abstract void Open( string X ) ;
		public abstract void Delete( string Command ) ;
		public abstract void Insert( string Command, string Filename ) ;
		public abstract void Get_Module( int Start_Block, int X, byte[] Buffer ) ;
		public abstract TModule_Info Get_Module_Info( int X ) ;
		public abstract int Size() ;
	} ; // TObject_Librarian

	public class TSObject_Librarian : TObject_Librarian
	{
		public override void Create_New( string Command,
			int Language_Id, int Typ )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override TUnified_Exception Get_Last_Error()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return null ;
		}

		public override void Extract( string Module, string Filename )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override void Extract_Index( int Module,
			string Filename, int Start_Block )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override void Open( string X )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override void Delete( string Command )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override void Insert( string Command, string Filename )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override void Get_Module( int Start_Block, int X,
			byte[] Buffer )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}

		public override TModule_Info Get_Module_Info( int X )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return null ;
		}

		public override int Size()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return 0 ;
		}

	} ; // TSObject_Librarian

	public class PSObject_Librarian : TSObject_Librarian
	{
	} ;
}

