<?php
/*
        Program Name : _Lib
        Package Name : Subroutine Library - Layer 1
        Purpose      : Abstract Object Librarian class definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 15-Dec-1988
        Written By   : Alan Conroy
        Version      : 1.0

		    Copyright (C) 1988-2021 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON                   

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************
*/

require_once "_Common" ; // TObject
require_once "CommBase" ; // TBase_Delphi_Object
require_once "_UE" ; // TUnified_Exception

const LibErr_Facility = 14 ;
const LibErr_Success = 0 ;
const LibErr_Invalid_Library_File_Format = 1 ;
const LibErr_Module_Not_Found = 2 ;
const LibErr_Module_Already_Exists = 3 ;
const LibErr_Illegal_Module_Format = 4 ;

class TModule_Info
{
	public $Name ;
	public $Size ;
	public $Day ;
	public $Month ;
	public $Year ;
	public $Hour ;
	public $Minute ;
    public $Flags ;
} ;

class TObject_Librarian extends TObject
{
	public $Creation_Hour ;
	public $Creation_Minute ;
	public $Creation_Day ;
	public $Creation_Month ;
	public $Creation_Year ;
	public $Deleted_Space ;
	public $Modified_Hour ;
	public $Modified_Minute ;
	public $Modified_Day ;
	public $Modified_Month ;
	public $Modified_Year ;
	public $Version ;

	public function Create_New( $Command, $Language_Id, $Typ )
	{
		Abstract_Error() ;
	}


    public function Get_Last_Error()
	{
		Abstract_Error() ;
		return NULL ;
	}


    public function Extract( $Module, $Filename )
	{
		Abstract_Error() ;
	}


    public function Extract_Index( $Module, $Filename, $Start_Block )
	{
		Abstract_Error() ;
	}


    public function Open( $X )
	{
		Abstract_Error() ;
	}


    public function Delete( $Command )
	{
		Abstract_Error() ;
	}


    public function Insert( $Command, $Filename )
	{
		Abstract_Error() ;
	}


    public function Get_Module( $Start_Block, $X, &$Buffer )
	{
		Abstract_Error() ;
	}


    public function Get_Module_Info( $X, &$Info )
	{
		Abstract_Error() ;
		return false ;
	}


    public function Size()
	{
		Abstract_Error() ;
		return 0 ;
	}
} ; // TObject_Librarian


class TSObject_Librarian extends TObject_Librarian
{
} ;


class PSObject_Librarian extends TSObject_Librarian
{
} ;
