/*
		Program Name : _NameVal
		Package Name : Subroutine Library - Layer 0
		Purpose      : Named values class definitions.
		Institution  : Conroy & Conroy Co.
		Date Written : 14-April-2008
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2008-2021 by Alan Conroy.  Released to the Public Domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************

		  TNamed_Values is a class that provides a set of values associated with
		a name.
*/

using System;
using _Common_unit;
using _Types_unit;

namespace _NameVal_unit
{
	public abstract class TNamed_Values : TDelphi_Object
	{
		public abstract int Index_Of( string Name ) ;
		public abstract int Index_Of_Value( string Value ) ;
		public abstract string Get( int Index ) ;
		public abstract string Get_Name( int Index ) ;
		public abstract int Put( int Index, string Value ) ;
		public abstract int Put_by_Name( string Name, string Value ) ;
		public abstract void Delete( int Index ) ;
	} ;


	public class TSNamed_Values : TNamed_Values
	{
		public override void Attach()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}


		public override bool Detach()
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return false ;
		}


		public override bool Is_Class( string S )
		{
			return ( S == "TSNamed_Values" ) ;
		}


		public override int Index_Of( string Name )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return -1 ;
		}


		public override int Index_Of_Value( string Value )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return - 1;
		}


		public override string Get( int Index )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return "" ;
		}


		public override string Get_Name( int Index )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return "" ;
		}


		public override int Put( int Index, string Value )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return -1 ;
		}


		public override int Put_by_Name( string Name, string Value )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
			return -1 ;
		}


		public override void Delete( int Index )
		{
			_Common C = new _Common() ;
			C.Abstract_Error() ;
		}
	} ;

	public class PSNamed_Values : TSNamed_Values
	{
	} ;
}
