/*
        Program Name : _NameVal
        Package Name : Subroutine Library - Layer 0
        Purpose      : Named values class definitions.
        Institution  : Conroy & Conroy Co.
        Date Written : 14-April-2008
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2008 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TNamed_Values is a class that provides a set of values associated with
        a name.
*/

#ifndef _NAMEVAL_HPP
  #define _NAMEVAL_HPP

// C&C Subroutine Library...
#include "eDefines.hpp"
#include "_Common.hpp"
#include "ComInter.hpp"
#include "_Types.hpp"

#include <string>

using namespace std;

class TNamed_Values: public TDelphi_Object
{
    public: // API...
                              virtual int Index_Of( string Name ) = 0 ;
                              virtual int Index_Of_Value( string Value ) = 0 ;
                              virtual string Get( int Index ) = 0 ;
                              virtual string Get_Name( int Index ) = 0 ;
                              virtual int Put( int Index, string Value ) = 0 ;
                              virtual int Put_by_Name( string Name, string Value ) = 0 ;
                              virtual void Delete( int Index ) = 0 ;
} ;

class TCOM_Named_Values: public TCommon_COM_Interface
{
    public: // API...
                                  virtual int stdcall Index_Of( char* Name ) = 0 ;
                                  virtual int stdcall Index_Of_Value( char* Value ) = 0 ;
                                  virtual char* stdcall Get( int Index ) = 0 ;
                                  virtual char* stdcall Get_Name( int Index ) = 0 ;
                                  virtual char* stdcall Put( int Index, char* Value ) = 0 ;
                                  virtual int stdcall Put_by_Name( char* Name, char* Value ) = 0 ;
                                  virtual void stdcall Delete( int Index ) = 0 ;
} ;

#define PSNamed_Values TSNamed_Values*

class TSNamed_Values: public TObject
{
    public: // API...
                              virtual int Index_Of( string Name ) ;
                              virtual int Index_Of_Value( string Value ) ;
                              virtual string Get( int Index ) ;
                              virtual string Get_Name( int Index ) ;
                              virtual int Put( int Index, string Value ) ;
                              virtual int Put_by_Name( string Name, string Value ) ;
                              virtual void Delete( int Index ) ;
} ;

#endif
