/*
        Program Name : _ObjectF
        Package Name : Subroutine Library - Layer 0
        Purpose      : Abstract Object Factory class
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Feb-2005
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TSObject_Factory is an abstract base class for classes which provide
        an indirect way of creating certain "standard" Subroutine Library
        classes.
*/

#ifndef _OBJECTF_HPP
	#define _OBJECTF_HPP

#include "eDefines.hpp"

// Subroutine library...
#include "_Common.hpp"
#include "_GenVal.hpp"
#include "_NameVal.hpp"
#include "_Propert.hpp"

class TSObject_Factory: public TObject
{
    public:
                                virtual PSDynamic_Properties Static_Dynamic_Properties() ;
                                virtual PSGeneric_Value Static_Generic_Value() ;
                                virtual PSNamed_Values Static_Named_Values() ;
                                virtual TCOM_Dynamic_Properties* COM_Dynamic_Properties() ;
                                virtual TDynamic_Properties* Dynamic_Properties() ;

                                virtual TCOM_Named_Values* COM_Named_Values( string Set_Name,
                                    bool Create )  ;
                                virtual TNamed_Values* Named_Values( string Set_Name,
                                    bool Create ) ;

                                virtual TCOM_Generic_Value* COM_Generic_Value() ;
                                virtual TGeneric_Value* Generic_Value() ;
} ;

#define PSObject_Factory TSObject_Factory*

PSObject_Factory Object_Factory = NULL; 

#endif
