/*
		Program Name : Text_Editor_Interface
		Package Name : Subroutine Library - layer 0
		Purpose      : Visual interface to a Text_Editor
		Institution  : Conroy & Conroy Co.
		Date Written :
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2012 by Alan Conroy.  All rights reserved.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************
*/

using System;
using CommBase_unit;

namespace _TE_Interface_unit
{
	public abstract class TText_Editor_Interface_Notifier : TBase_Delphi_Object
	{
		public abstract void Cursor_Change( int R, int C ) ;
		public abstract void Line_Read( int R ) ;
	} ;


	public class TText_Editor_Position
	{
		public int Row ;
		public int Column ;
	} ;


	public abstract class TText_Editor_Interface : TBase_Delphi_Object
	{
		public abstract void Set_Parent( int Handle ) ;
		public abstract int Get_Parent() ;
		public abstract void Set_Size( int Height, int Width ) ;
		public abstract int Column_Count() ;
		public abstract int Line_Count() ;

		public abstract void Set_Background( uint color ) ;
		public abstract void Set_Foreground( uint color ) ;
		public abstract void Set_Font( string Name ) ;
		public abstract void Set_Font_Size( int Siz ) ;

		public abstract void Load_File( string Nam ) ;
		public abstract void Save_File( string Nam ) ;

		public abstract string Get_Line( int Row ) ;

		public abstract void Locate( string S, ref int R, ref int C, bool CS ) ;
		public abstract void Position_To( int R, int C ) ;
		public abstract void Get_Position( ref int R, ref int C ) ;
		public abstract void Set_Notifier( TText_Editor_Interface_Notifier V ) ;
		public abstract void Key_Down( ref ushort Key, uint Shift ) ;
		public abstract void Bring_Cursor_Into_View() ;
		public abstract void SetFocus() ;
		public abstract void Set_Position( TText_Editor_Position P ) ;
		public abstract string Get_Selected_Text() ;

		public int Parent
		{
		  get { return Get_Parent(); }
		  set { Set_Parent( value ); }
		}
	} ;
}
