/*
		Program Name : Text_Editor_Interface
		Package Name : Subroutine Library - layer 0
		Purpose      : Visual interface to a Text_Editor
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2012 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
		*                                                           *
        *************************************************************
*/

#ifndef _TE_INTERFACE_HPP
	#define _TE_INTERFACE_HPP

#include "eDefines.hpp"

// C&C Subroutine Library - layer 0...
#include "CommBase.hpp"
#include <string>

using namespace std;

#pragma pack(1)

struct TText_Editor_Position
{
	int32 Row ;
	int32 Column ;
} ;


class TText_Editor_Interface_Notifier: public TBase_Delphi_Object
{
	public: // API...
		virtual void stdcall Cursor_Change( int32 R, int32 C ) = 0 ;
		virtual void stdcall Line_Read( int32 R ) = 0 ;
} ;


class TText_Editor_Interface: public TBase_Delphi_Object
{
	public: // API...
		  virtual void stdcall Set_Parent( int Handle ) = 0 ;
		  virtual int stdcall Get_Parent() = 0 ;
		  virtual void stdcall Set_Size( int32 Height, int32 Width ) = 0 ;
		  virtual int32 stdcall Column_Count() = 0 ;
		  virtual int32 stdcall Line_Count() = 0 ;

		  virtual void stdcall Set_Background( int32 Color ) = 0 ;
		  virtual void stdcall Set_Foreground( int32 Color ) = 0 ;
		  virtual void stdcall Set_Font( char* Name ) = 0 ;
		  virtual void stdcall Set_Font_Size( int32 Siz ) = 0 ;

		  virtual void stdcall Load_File( char* Nam ) = 0 ;
		  virtual void stdcall Save_File( char* Nam ) = 0 ;

		  virtual char* stdcall Get_Line( int32 Row ) = 0 ;

		  virtual void stdcall Locate( string S,
			  int32 &R, int32 &C, bool CS ) = 0 ;
		  virtual void stdcall Position_To( int32 R, int32 C ) = 0 ;
		  virtual void stdcall Get_Position( int32 &R, int32 &C ) = 0 ;
		  virtual void stdcall Set_Notifier( TText_Editor_Interface_Notifier* V ) = 0  ;
		  virtual void stdcall Key_Down( uint16 &Key, int32 Shift ) = 0 ;
		  virtual void stdcall Bring_Cursor_Into_View() = 0 ;
		  virtual void stdcall SetFocus() = 0 ;
		  virtual void stdcall Set_Position( TText_Editor_Position P ) = 0 ;
		  virtual string stdcall Get_Selected_Text() = 0 ;

	public:
		  int Parent() {return Get_Parent();};
} ;

#endif

