/*
		Program Name : _UE
		Package Name : Subroutine Library - Layer 0
		Purpose      : UE definitions
		Institution  : Conroy & Conroy Co.
		Date Written : 9-Feb-2013
		Last Modified:
		Written By   : Alan Conroy
		Version      : 1.0

		Copyright (C) 2013-2021 by Alan Conroy.  Released to the public domain.

		TO THE GLORY OF GOD THROUGH JESUS CHRIST

		*************************************************************
		*                                                           *
		*        M O D I F I C A T I O N   H I S T O R Y            *
		*                                                           *
		*************************************************************

			DATE        BY          REASON

		*************************************************************
		*                                                           *
		*        P R O G R A M   P U R P O S E                      *
		*                                                           *
		*************************************************************

	  This unit provides definitions for UE (Unified Exceptions).
*/

using System;
using _Common_unit ;

namespace _UE_unit
{
	public partial class _UE
	{
		public const int UE_Success = 0 ;
		public const int UE_Informational = 1 ;
		public const int UE_Warning = 2 ;
		public const int UE_Error = 3 ;
		public const int UE_Fatal = 4 ;
	} ;


	public class TUnified_Exception
	{
		private int _Reference_Count ;


		public void Attach()
		{
			_Reference_Count++ ;
		}


		public bool Detach()
		{
			_Reference_Count-- ;
			return ( _Reference_Count == 0 );
		}


		public int Get_Facility()
		{
			_Common C = new _Common();
			C.Abstract_Error()  ;
			return -1 ;
		}


		public int Get_Facility_Version()
		{
			_Common C = new _Common();
			C.Abstract_Error()  ;
			return 0 ;
		}


		public int Version()
		{
			return 10 ; // Complies with 1.0 of the Unified Exception specification
		}


		public int Severity()
		{
			_Common C = new _Common();
			C.Abstract_Error()  ;
			return _UE.UE_Error ;
		}


		public string Error_Text( ref int Size, ref int Typ )
		{
			Size = 0 ;
			Typ = 0 ;
			_Common C = new _Common();
			C.Abstract_Error()  ;
			return "" ;
		}


		public int Get_Error()
		{
			_Common C = new _Common();
			C.Abstract_Error()  ;
			return 0 ;
		}


		public TUnified_Exception Get_Previous()
		{
			return null ;
		}


		public void Terminate()
		{
			// Does nothing.  Exists solely for overrides.
		}


		public void Free()
		{
			Terminate() ;
		}


		public int Facility()
		{
			return Get_Facility() ;
		}


		public int Facility_Version()
		{
			return Get_Facility_Version() ;
		}


		public int Code()
		{
			return Get_Error() ;
		}
	} ;


	public class TSUnified_Exception : TUnified_Exception
	{
	} ;

	public class PSUnified_Exception : TSUnified_Exception
	{
	} ;



	public partial class _UE
	{
		public void Fatal_Error( TUnified_Exception E )
		{
			int _S = 0 ;
			int _T = 0 ;

			string S = E.Error_Text( ref _S, ref _T ) ;
			throw new Exception( S ) ;
		}
	} ;
}
