#        Program Name : _UE
#        Package Name : Subroutine Library - Layer 0
#        Purpose      : UE definitions
#        Institution  : Conroy & Conroy Co.
#        Date Written : 9-Feb-2013
#        Last Modified:
#        Written By   : Alan Conroy
#        Version      : 1.0
#
#        Copyright (C) 2013-2021 by Alan Conroy.  Released to the public domain.
#
#        TO THE GLORY OF GOD THROUGH JESUS CHRIST
#
#        *************************************************************
#        *                                                           *
#        *        M O D I F I C A T I O N   H I S T O R Y            *
#        *                                                           *
#        *************************************************************
#
#            DATE        BY          REASON
#
#        *************************************************************
#        *                                                           *
#        *        P R O G R A M   P U R P O S E                      *
#        *                                                           *
#        *************************************************************
#
#     This unit provides definitions for UE (Unified Exceptions).

from _Common import *
from _Types import *
from _DebugIn import *

import sys;

UE_Success = 0
UE_Informational = 1
UE_Warning = 2
UE_Error = 3
UE_Fatal = 4


class TUnified_Exception():

    def Attach( self ):
        ++self._Reference_Count


    def Detach( self ):
        --self._Reference_Count
        if( self._Reference_Count <= 0 ):
            del self
            return true
        return false


    def Get_Facility( self ):
        Abstract_Error()
        return -1


    def Get_Facility_Version( self ):
        Abstract_Error()
        return 0


    def Version( self ):
        return 10 # Complies with 1.0 of the Unified Exception specification


    def Severity( self ):
        Abstract_Error()
        return UE_Error


    def Error_Text( self, Size, Typ ):
        self.Error_Text = ""
        self.Size = 0
        self.Typ = 0
        Abstract_Error()


    def Get_Error( self ):
        Abstract_Error()
        return 0


    def Get_Previous( self ):
        return None


    def Terminate( self ):
        # Does nothing.  Exists solely for overrides.
        pass


    def Free( self ):
        Terminate()
        super().Free()


    def Facility( self ):
        return self.Get_Facility


    def Facility_Version( self ):
        return self.Get_Facility_Version()


    def Code( self ):
        return self.Get_Error()


class TSUnified_Exception( TUnified_Exception ):
    pass

class PSUnified_Exception( TSUnified_Exception ):
    pass

def Fatal_Error( E ):
    S = ""
    _S, _T = 0 ;

    S = E.Error_Text( _S, _T )
    del E
    raise Exception( S )
    print( S )
    sys.exit()
